GROUP( control)
I_noop: /* noop ( -- ) */
/*  */
NAME("noop")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 138 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "noop");
NEXT_P2;}

I_lit: /* lit ( #w -- w ) */
/*  */
NAME("lit")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
w = vm_Cell2w(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
INC_IP(1);
sp += -1;
{
#line 142 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "lit");
NEXT_P2;}

I_execute: /* execute ( xt -- ) */
/* Perform the semantics represented by the execution token, @i{xt}. */
NAME("execute")
{
DEF_CA
Xt xt;
NEXT_P0;
xt = vm_Cell2xt(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
sp += 1;
{
#line 147 "./prim"
ip=IP;
IF_spTOS(spTOS = sp[0]);
SUPER_END;
cfa=xt; trace_btb(0,"execute");
EXEC(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "execute");
NEXT_P2;}

I_perform: /* perform ( a_addr -- ) */
/* @code{@@ execute}. */
NAME("perform")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 155 "./prim"
/* and pfe */
ip=IP;
IF_spTOS(spTOS = sp[0]);
SUPER_END;
cfa=*(Xt*)a_addr; trace_btb(0,"perform");
EXEC(*(Xt *)a_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "perform");
NEXT_P2;}

#ifdef HAS_GLOCALS
I_branch_lp_plus_store_number: /* branch-lp+!# ( #ndisp #nlocals -- ) */
/*  */
NAME("branch-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlocals = vm_Cell2n(IP[1]);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
}
#endif
INC_IP(2);
{
#line 168 "./prim"
/* this will probably not be used */
lp += nlocals;
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "branch-lp+!#");
NEXT_P2;}

#endif
I_branch: /* branch ( #ndisp -- ) */
/*  */
NAME("branch")
{
DEF_CA
Cell ndisp;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
}
#endif
INC_IP(1);
{
#line 175 "./prim"
SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "branch");
NEXT_P2;}

I_question_branch: /* ?branch ( #ndisp f -- ) */
/*  */
NAME("?branch")
{
DEF_CA
Cell ndisp;
Bool f;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
f = vm_Cell2f(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(1);
sp += 1;
{
#line 206 "./prim"
if (f==0) {
#line 206
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 206
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "?branch");
NEXT_P2;
#line 206
}
#line 206
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "?branch");
NEXT_P2;}

#ifdef HAS_GLOCALS
I_question_branch_lp_plus_store_number: /* ?branch-lp+!# ( #ndisp #nlocals f -- ) */
/*  */
NAME("?branch-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Bool f;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlocals = vm_Cell2n(IP[1]);
f = vm_Cell2f(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(2);
sp += 1;
{
#line 206 "./prim"
if (f==0) {
#line 206
    lp += nlocals;
#line 206
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 206
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "?branch-lp+!#");
NEXT_P2;
#line 206
}
#line 206
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "?branch-lp+!#");
NEXT_P2;}

#endif
#ifdef HAS_XCONDS
I_question_dupe_question_branch: /* ?dup-?branch ( #ndisp f -- f ) */
/* The run-time procedure compiled by @code{?DUP-IF}. */
NAME("?dup-?branch")
{
DEF_CA
Cell ndisp;
Bool f;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
f = vm_Cell2f(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(1);
{
#line 215 "./prim"
if (f==0) {
  sp++;
  IF_spTOS(spTOS = sp[0]);
  SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
  SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "?dup-?branch");
NEXT_P2;
}
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(1 , "?dup-?branch");
NEXT_P2;}

I_question_dupe_zero_equals_question_branch: /* ?dup-0=-?branch ( #ndisp f -- ) */
/* The run-time procedure compiled by @code{?DUP-0=-IF}. */
NAME("?dup-0=-?branch")
{
DEF_CA
Cell ndisp;
Bool f;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
f = vm_Cell2f(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(1);
sp += 1;
{
#line 224 "./prim"
/* the approach taken here of declaring the word as having the stack
effect ( f -- ) and correcting for it in the branch-taken case costs a
few cycles in that case, but is easy to convert to a CONDBRANCH
invocation */
if (f!=0) {
  sp--;
  SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
  NEXT;
}
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "?dup-0=-?branch");
NEXT_P2;}

#endif
I_paren_next: /* (next) ( #ndisp R:n1 -- R:n2 ) */
/*  */
NAME("(next)")
{
DEF_CA
Cell ndisp;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
{
#line 243 "./prim"
n2=n1-1;
#line 243
if (n1) {
#line 243
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 243
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(0 , "(next)");
NEXT_P2;
#line 243
}
#line 243
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(1 , "(next)");
NEXT_P2;}

#ifdef HAS_GLOCALS
I_paren_next_lp_plus_store_number: /* (next)-lp+!# ( #ndisp #nlocals R:n1 -- R:n2 ) */
/*  */
NAME("(next)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlocals = vm_Cell2n(IP[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
{
#line 243 "./prim"
n2=n1-1;
#line 243
if (n1) {
#line 243
    lp += nlocals;
#line 243
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 243
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(0 , "(next)-lp+!#");
NEXT_P2;
#line 243
}
#line 243
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(1 , "(next)-lp+!#");
NEXT_P2;}

#endif
I_paren_loop: /* (loop) ( #ndisp R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(loop)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
{
#line 251 "./prim"
n2=n1+1;
#line 251
if (n2 != nlimit) {
#line 251
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 251
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(0 , "(loop)");
NEXT_P2;
#line 251
}
#line 251
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(1 , "(loop)");
NEXT_P2;}

#ifdef HAS_GLOCALS
I_paren_loop_lp_plus_store_number: /* (loop)-lp+!# ( #ndisp #nlocals R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlocals = vm_Cell2n(IP[1]);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
{
#line 251 "./prim"
n2=n1+1;
#line 251
if (n2 != nlimit) {
#line 251
    lp += nlocals;
#line 251
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 251
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(0 , "(loop)-lp+!#");
NEXT_P2;
#line 251
}
#line 251
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
trace_btb(1 , "(loop)-lp+!#");
NEXT_P2;}

#endif
I_paren_plus_loop: /* (+loop) ( #ndisp n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(+loop)")
{
DEF_CA
Cell ndisp;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
n = vm_Cell2n(spTOS);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
sp += 1;
{
#line 267 "./prim"
/* !! check this thoroughly */
#line 267
/* sign bit manipulation and test: (x^y)<0 is equivalent to (x<0) != (y<0) */
#line 267
/* dependent upon two's complement arithmetic */
#line 267
Cell olddiff = n1-nlimit;
#line 267
n2=n1+n;	
#line 267
if ((olddiff^(olddiff+n))>=0   /* the limit is not crossed */
#line 267
    || (olddiff^n)>=0          /* it is a wrap-around effect */) {
#line 267
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 267
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(+loop)");
NEXT_P2;
#line 267
}
#line 267
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(+loop)");
NEXT_P2;}

#ifdef HAS_GLOCALS
I_paren_plus_loop_lp_plus_store_number: /* (+loop)-lp+!# ( #ndisp #nlocals n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(+loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlocals = vm_Cell2n(IP[1]);
n = vm_Cell2n(spTOS);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
sp += 1;
{
#line 267 "./prim"
/* !! check this thoroughly */
#line 267
/* sign bit manipulation and test: (x^y)<0 is equivalent to (x<0) != (y<0) */
#line 267
/* dependent upon two's complement arithmetic */
#line 267
Cell olddiff = n1-nlimit;
#line 267
n2=n1+n;	
#line 267
if ((olddiff^(olddiff+n))>=0   /* the limit is not crossed */
#line 267
    || (olddiff^n)>=0          /* it is a wrap-around effect */) {
#line 267
    lp += nlocals;
#line 267
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 267
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(+loop)-lp+!#");
NEXT_P2;
#line 267
}
#line 267
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(+loop)-lp+!#");
NEXT_P2;}

#endif
#ifdef HAS_XCONDS
I_paren_minus_loop: /* (-loop) ( #ndisp u R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(-loop)")
{
DEF_CA
Cell ndisp;
UCell u;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
u = vm_Cell2u(spTOS);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" u=", vm_out); printarg_u(u);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
sp += 1;
{
#line 275 "./prim"
UCell olddiff = n1-nlimit;
#line 275
n2=n1-u;
#line 275
if (olddiff>u) {
#line 275
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 275
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(-loop)");
NEXT_P2;
#line 275
}
#line 275
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(-loop)");
NEXT_P2;}

#ifdef HAS_GLOCALS
I_paren_minus_loop_lp_plus_store_number: /* (-loop)-lp+!# ( #ndisp #nlocals u R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(-loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
UCell u;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlocals = vm_Cell2n(IP[1]);
u = vm_Cell2u(spTOS);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" u=", vm_out); printarg_u(u);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
sp += 1;
{
#line 275 "./prim"
UCell olddiff = n1-nlimit;
#line 275
n2=n1-u;
#line 275
if (olddiff>u) {
#line 275
    lp += nlocals;
#line 275
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 275
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(-loop)-lp+!#");
NEXT_P2;
#line 275
}
#line 275
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(-loop)-lp+!#");
NEXT_P2;}

#endif
I_paren_symmetric_plus_loop: /* (s+loop) ( #ndisp n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/* The run-time procedure compiled by S+LOOP. It loops until the index
crosses the boundary between limit and limit-sign(n). I.e. a symmetric
version of (+LOOP). */
NAME("(s+loop)")
{
DEF_CA
Cell ndisp;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
n = vm_Cell2n(spTOS);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
sp += 1;
{
#line 290 "./prim"
/* !! check this thoroughly */
#line 290
Cell diff = n1-nlimit;
#line 290
Cell newdiff = diff+n;
#line 290
if (n<0) {
#line 290
    diff = -diff;
#line 290
    newdiff = -newdiff;
#line 290
}
#line 290
n2=n1+n;
#line 290
if (diff>=0 || newdiff<0) {
#line 290
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 290
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(s+loop)");
NEXT_P2;
#line 290
}
#line 290
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(s+loop)");
NEXT_P2;}

#ifdef HAS_GLOCALS
I_paren_symmetric_plus_loop_lp_plus_store_number: /* (s+loop)-lp+!# ( #ndisp #nlocals n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/* The run-time procedure compiled by S+LOOP. It loops until the index
crosses the boundary between limit and limit-sign(n). I.e. a symmetric
version of (+LOOP). */
NAME("(s+loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
ndisp = vm_Cell2n(IPTOS);
nlocals = vm_Cell2n(IP[1]);
n = vm_Cell2n(spTOS);
nlimit = vm_Cell2n(rp[1]);
n1 = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
sp += 1;
{
#line 290 "./prim"
/* !! check this thoroughly */
#line 290
Cell diff = n1-nlimit;
#line 290
Cell newdiff = diff+n;
#line 290
if (n<0) {
#line 290
    diff = -diff;
#line 290
    newdiff = -newdiff;
#line 290
}
#line 290
n2=n1+n;
#line 290
if (diff>=0 || newdiff<0) {
#line 290
    lp += nlocals;
#line 290
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 290
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(s+loop)-lp+!#");
NEXT_P2;
#line 290
}
#line 290
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_n2Cell(n2);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(s+loop)-lp+!#");
NEXT_P2;}

#endif
#endif
I_unloop: /* unloop ( R:w1 R:w2 -- ) */
/*  */
NAME("unloop")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(rp[1]);
w2 = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
rp += 2;
{
#line 295 "./prim"
/* !! alias for 2rdrop */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
trace_btb(0 , "unloop");
NEXT_P2;}

I_paren_for: /* (for) ( ncount -- R:nlimit R:ncount ) */
/*  */
NAME("(for)")
{
DEF_CA
Cell ncount;
Cell nlimit;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
ncount = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ncount=", vm_out); printarg_n(ncount);
}
#endif
sp += 1;
rp += -2;
{
#line 300 "./prim"
/* or (for) = >r -- collides with unloop! */
nlimit=0;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(ncount);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(for)");
NEXT_P2;}

I_paren_do: /* (do) ( nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(do)")
{
DEF_CA
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
nlimit = vm_Cell2n(sp[1]);
nstart = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
sp += 2;
rp += -2;
{
#line 306 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(nstart);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(do)");
NEXT_P2;}

I_paren_question_do: /* (?do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(?do)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
ndisp = vm_Cell2n(IPTOS);
nlimit = vm_Cell2n(sp[1]);
nstart = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 310 "./prim"
if (nstart == nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(nstart);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(?do)");
NEXT_P2;
}
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(nstart);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(?do)");
NEXT_P2;}

#ifdef HAS_XCONDS
I_paren_plus_do: /* (+do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(+do)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
ndisp = vm_Cell2n(IPTOS);
nlimit = vm_Cell2n(sp[1]);
nstart = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 325 "./prim"
if (nstart >= nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(nstart);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(+do)");
NEXT_P2;
}
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(nstart);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(+do)");
NEXT_P2;}

I_paren_u_plus_do: /* (u+do) ( #ndisp ulimit ustart -- R:ulimit R:ustart ) */
/*  */
NAME("(u+do)")
{
DEF_CA
Cell ndisp;
UCell ulimit;
UCell ustart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
ndisp = vm_Cell2n(IPTOS);
ulimit = vm_Cell2u(sp[1]);
ustart = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" ulimit=", vm_out); printarg_u(ulimit);
fputs(" ustart=", vm_out); printarg_u(ustart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 340 "./prim"
if (ustart >= ulimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_u2Cell(ulimit);
rpTOS = vm_u2Cell(ustart);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(u+do)");
NEXT_P2;
}
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_u2Cell(ulimit);
rpTOS = vm_u2Cell(ustart);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(u+do)");
NEXT_P2;}

I_paren_minus_do: /* (-do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(-do)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
ndisp = vm_Cell2n(IPTOS);
nlimit = vm_Cell2n(sp[1]);
nstart = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 355 "./prim"
if (nstart <= nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(nstart);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(-do)");
NEXT_P2;
}
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_n2Cell(nlimit);
rpTOS = vm_n2Cell(nstart);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(-do)");
NEXT_P2;}

I_paren_u_minus_do: /* (u-do) ( #ndisp ulimit ustart -- R:ulimit R:ustart ) */
/*  */
NAME("(u-do)")
{
DEF_CA
Cell ndisp;
UCell ulimit;
UCell ustart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
ndisp = vm_Cell2n(IPTOS);
ulimit = vm_Cell2u(sp[1]);
ustart = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" ulimit=", vm_out); printarg_u(ulimit);
fputs(" ustart=", vm_out); printarg_u(ustart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 370 "./prim"
if (ustart <= ulimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_u2Cell(ulimit);
rpTOS = vm_u2Cell(ustart);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(u-do)");
NEXT_P2;
}
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_u2Cell(ulimit);
rpTOS = vm_u2Cell(ustart);
IF_spTOS(spTOS = sp[0]);
trace_btb(1 , "(u-do)");
NEXT_P2;}

#endif
I_i: /* i ( R:n -- R:n n ) */
/*  */
NAME("i")
{
DEF_CA
Cell n;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
n = vm_Cell2n(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += -1;
{
#line 390 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "i");
NEXT_P2;}

I_i_tick: /* i' ( R:w R:w2 -- R:w R:w2 w ) */
/*  */
NAME("i'")
{
DEF_CA
Cell w;
Cell w2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
w = vm_Cell2w(rp[1]);
w2 = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -1;
{
#line 395 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "i'");
NEXT_P2;}

I_j: /* j ( R:n R:d1 -- n R:n R:d1 ) */
/*  */
NAME("j")
{
DEF_CA
Cell n;
DCell d1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
n = vm_Cell2n(rp[2]);
vm_twoCell2d(d1, (Cell)rp[1], (Cell)rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
sp += -1;
{
#line 401 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
vm_d2twoCell(d1, rp[1], rpTOS);
trace_btb(0 , "j");
NEXT_P2;}

I_k: /* k ( R:n R:d1 R:d2 -- n R:n R:d1 R:d2 ) */
/*  */
NAME("k")
{
DEF_CA
Cell n;
DCell d1;
DCell d2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
n = vm_Cell2n(rp[4]);
vm_twoCell2d(d1, (Cell)rp[3], (Cell)rp[2]);
vm_twoCell2d(d2, (Cell)rp[1], (Cell)rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += -1;
{
#line 407 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
vm_d2twoCell(d1, rp[3], rp[2]);
vm_d2twoCell(d2, rp[1], rpTOS);
trace_btb(0 , "k");
NEXT_P2;}

GROUP( strings)
I_move: /* move ( c_from c_to ucount -- ) */
/* Copy the contents of @i{ucount} aus at @i{c-from} to
@i{c-to}. @code{move} works correctly even if the two areas overlap. */
NAME("move")
{
DEF_CA
Char * c_from;
Char * c_to;
UCell ucount;
NEXT_P0;
c_from = vm_Cell2c_(sp[2]);
c_to = vm_Cell2c_(sp[1]);
ucount = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
sp += 3;
{
#line 421 "./prim"
/* !! note that the standard specifies addr, not c-addr */
memmove(c_to,c_from,ucount);
/* make an Ifdef for bsd and others? */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "move");
NEXT_P2;}

I_c_move: /* cmove ( c_from c_to u -- ) */
/* Copy the contents of @i{ucount} characters from data space at
@i{c-from} to @i{c-to}. The copy proceeds @code{char}-by-@code{char}
from low address to high address; i.e., for overlapping areas it is
safe if @i{c-to}=<@i{c-from}. */
NAME("cmove")
{
DEF_CA
Char * c_from;
Char * c_to;
UCell u;
NEXT_P0;
c_from = vm_Cell2c_(sp[2]);
c_to = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
{
#line 432 "./prim"
while (u-- > 0)
  *c_to++ = *c_from++;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "cmove");
NEXT_P2;}

I_c_move_up: /* cmove> ( c_from c_to u -- ) */
/* Copy the contents of @i{ucount} characters from data space at
@i{c-from} to @i{c-to}. The copy proceeds @code{char}-by-@code{char}
from high address to low address; i.e., for overlapping areas it is
safe if @i{c-to}>=@i{c-from}. */
NAME("cmove>")
{
DEF_CA
Char * c_from;
Char * c_to;
UCell u;
NEXT_P0;
c_from = vm_Cell2c_(sp[2]);
c_to = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
{
#line 442 "./prim"
while (u-- > 0)
  c_to[u] = c_from[u];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "cmove>");
NEXT_P2;}

I_fill: /* fill ( c_addr u c -- ) */
/* Store @i{c} in @i{u} chars starting at @i{c-addr}. */
NAME("fill")
{
DEF_CA
Char * c_addr;
UCell u;
Char c;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
c = vm_Cell2c(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c=", vm_out); printarg_c(c);
}
#endif
sp += 3;
{
#line 451 "./prim"
memset(c_addr,c,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fill");
NEXT_P2;}

I_compare: /* compare ( c_addr1 u1 c_addr2 u2 -- n ) */
/* Compare two strings lexicographically. If they are equal, @i{n} is 0; if
the first string is smaller, @i{n} is -1; if the first string is larger, @i{n}
is 1. Currently this is based on the machine's character
comparison. In the future, this may change to consider the current
locale and its collation order. */
NAME("compare")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
Cell n;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[3]);
u1 = vm_Cell2u(sp[2]);
c_addr2 = vm_Cell2c_(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 3;
{
#line 462 "./prim"
/* close ' to keep fontify happy */ 
n = memcmp(c_addr1, c_addr2, u1<u2 ? u1 : u2);
if (n==0)
  n = u1-u2;
if (n<0)
  n = -1;
else if (n>0)
  n = 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "compare");
NEXT_P2;}

I_dash_text: /* -text ( c_addr1 u c_addr2 -- n ) */
/*  */
NAME("-text")
{
DEF_CA
Char * c_addr1;
UCell u;
Char * c_addr2;
Cell n;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
c_addr2 = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
}
#endif
sp += 2;
{
#line 477 "./prim"
n = memcmp(c_addr1, c_addr2, u);
if (n<0)
  n = -1;
else if (n>0)
  n = 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "-text");
NEXT_P2;}

I_toupper: /* toupper ( c1 -- c2 ) */
/* If @i{c1} is a lower-case character (in the current locale), @i{c2}
is the equivalent upper-case character. All other characters are unchanged. */
NAME("toupper")
{
DEF_CA
Char c1;
Char c2;
NEXT_P0;
c1 = vm_Cell2c(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c1=", vm_out); printarg_c(c1);
}
#endif
{
#line 492 "./prim"
c2 = toupper(c1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c2=", vm_out); printarg_c(c2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_c2Cell(c2);
trace_btb(0 , "toupper");
NEXT_P2;}

I_capscomp: /* capscomp ( c_addr1 u c_addr2 -- n ) */
/*  */
NAME("capscomp")
{
DEF_CA
Char * c_addr1;
UCell u;
Char * c_addr2;
Cell n;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
c_addr2 = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
}
#endif
sp += 2;
{
#line 497 "./prim"
n = memcasecmp(c_addr1, c_addr2, u); /* !! use something that works in all locales */
if (n<0)
  n = -1;
else if (n>0)
  n = 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "capscomp");
NEXT_P2;}

I_dash_trailing: /* -trailing ( c_addr u1 -- c_addr u2 ) */
/* Adjust the string specified by @i{c-addr, u1} to remove all trailing
spaces. @i{u2} is the length of the modified string. */
NAME("-trailing")
{
DEF_CA
Char * c_addr;
UCell u1;
UCell u2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u1 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
{
#line 512 "./prim"
u2 = u1;
while (u2>0 && c_addr[u2-1] == ' ')
  u2--;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(u2);
trace_btb(0 , "-trailing");
NEXT_P2;}

I_slash_string: /* /string ( c_addr1 u1 n -- c_addr2 u2 ) */
/* Adjust the string specified by @i{c-addr1, u1} to remove @i{n}
characters from the start of the string. */
NAME("/string")
{
DEF_CA
Char * c_addr1;
UCell u1;
Cell n;
Char * c_addr2;
UCell u2;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[2]);
u1 = vm_Cell2u(sp[1]);
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 522 "./prim"
c_addr2 = c_addr1+n;
u2 = u1-n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_c_2Cell(c_addr2);
spTOS = vm_u2Cell(u2);
trace_btb(0 , "/string");
NEXT_P2;}

GROUP( arith)
I_plus: /* + ( n1 n2 -- n ) */
/*  */
NAME("+")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 530 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "+");
NEXT_P2;}

I_under_plus: /* under+ ( n1 n2 n3 -- n n2 ) */
/* add @i{n3} to @i{n1} (giving @i{n}) */
NAME("under+")
{
DEF_CA
Cell n1;
Cell n2;
Cell n3;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[2]);
n2 = vm_Cell2n(sp[1]);
n3 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
fputs(" n3=", vm_out); printarg_n(n3);
}
#endif
sp += 1;
{
#line 535 "./prim"
n = n1+n3;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_n2Cell(n);
IF_spTOS(spTOS = vm_n2Cell(n2););
trace_btb(0 , "under+");
NEXT_P2;}

I_minus: /* - ( n1 n2 -- n ) */
/*  */
NAME("-")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 540 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "-");
NEXT_P2;}

I_negate: /* negate ( n1 -- n2 ) */
/*  */
NAME("negate")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 545 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "negate");
NEXT_P2;}

I_one_plus: /* 1+ ( n1 -- n2 ) */
/*  */
NAME("1+")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 551 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "1+");
NEXT_P2;}

I_one_minus: /* 1- ( n1 -- n2 ) */
/*  */
NAME("1-")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 556 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "1-");
NEXT_P2;}

I_max: /* max ( n1 n2 -- n ) */
/*  */
NAME("max")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 561 "./prim"
if (n1<n2)
  n = n2;
else
  n = n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "max");
NEXT_P2;}

I_min: /* min ( n1 n2 -- n ) */
/*  */
NAME("min")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 569 "./prim"
if (n1<n2)
  n = n1;
else
  n = n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "min");
NEXT_P2;}

I_abs: /* abs ( n -- u ) */
/*  */
NAME("abs")
{
DEF_CA
Cell n;
UCell u;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 577 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(u);
trace_btb(0 , "abs");
NEXT_P2;}

I_star: /* * ( n1 n2 -- n ) */
/*  */
NAME("*")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 585 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "*");
NEXT_P2;}

I_slash: /* / ( n1 n2 -- n ) */
/*  */
NAME("/")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 590 "./prim"
n = n1/n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "/");
NEXT_P2;}

I_mod: /* mod ( n1 n2 -- n ) */
/*  */
NAME("mod")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 595 "./prim"
n = n1%n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "mod");
NEXT_P2;}

I_slash_mod: /* /mod ( n1 n2 -- n3 n4 ) */
/*  */
NAME("/mod")
{
DEF_CA
Cell n1;
Cell n2;
Cell n3;
Cell n4;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 600 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_n2Cell(n3);
spTOS = vm_n2Cell(n4);
trace_btb(0 , "/mod");
NEXT_P2;}

I_two_star: /* 2* ( n1 -- n2 ) */
/* Shift left by 1; also works on unsigned numbers */
NAME("2*")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 607 "./prim"
n2 = 2*n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "2*");
NEXT_P2;}

I_two_slash: /* 2/ ( n1 -- n2 ) */
/* Arithmetic shift right by 1.  For signed numbers this is a floored
division by 2 (note that @code{/} not necessarily floors). */
NAME("2/")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 614 "./prim"
n2 = n1>>1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "2/");
NEXT_P2;}

I_f_m_slash_mod: /* fm/mod ( d1 n1 -- n2 n3 ) */
/* Floored division: @i{d1} = @i{n3}*@i{n1}+@i{n2}, @i{n1}>@i{n2}>=0 or 0>=@i{n2}>@i{n1}. */
NAME("fm/mod")
{
DEF_CA
DCell d1;
Cell n1;
Cell n2;
Cell n3;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[2], (Cell)sp[1]);
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
sp += 1;
{
#line 624 "./prim"
#ifdef BUGGY_LONG_LONG
DCell r = fmdiv(d1,n1);
n2=r.hi;
n3=r.lo;
#else
/* assumes that the processor uses either floored or symmetric division */
n3 = d1/n1;
n2 = d1%n1;
/* note that this 1%-3>0 is optimized by the compiler */
if (1%-3>0 && (d1<0) != (n1<0) && n2!=0) {
  n3--;
  n2+=n1;
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputs(" n3=", vm_out); printarg_n(n3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_n2Cell(n2);
spTOS = vm_n2Cell(n3);
trace_btb(0 , "fm/mod");
NEXT_P2;}

I_s_m_slash_rem: /* sm/rem ( d1 n1 -- n2 n3 ) */
/* Symmetric division: @i{d1} = @i{n3}*@i{n1}+@i{n2}, sign(@i{n2})=sign(@i{d1}) or 0. */
NAME("sm/rem")
{
DEF_CA
DCell d1;
Cell n1;
Cell n2;
Cell n3;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[2], (Cell)sp[1]);
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
sp += 1;
{
#line 646 "./prim"
#ifdef BUGGY_LONG_LONG
DCell r = smdiv(d1,n1);
n2=r.hi;
n3=r.lo;
#else
/* assumes that the processor uses either floored or symmetric division */
n3 = d1/n1;
n2 = d1%n1;
/* note that this 1%-3<0 is optimized by the compiler */
if (1%-3<0 && (d1<0) != (n1<0) && n2!=0) {
  n3++;
  n2-=n1;
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputs(" n3=", vm_out); printarg_n(n3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_n2Cell(n2);
spTOS = vm_n2Cell(n3);
trace_btb(0 , "sm/rem");
NEXT_P2;}

I_m_star: /* m* ( n1 n2 -- d ) */
/*  */
NAME("m*")
{
DEF_CA
Cell n1;
Cell n2;
DCell d;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 667 "./prim"
#ifdef BUGGY_LONG_LONG
d = mmul(n1,n2);
#else
d = (DCell)n1 * (DCell)n2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS);
trace_btb(0 , "m*");
NEXT_P2;}

I_u_m_star: /* um* ( u1 u2 -- ud ) */
/*  */
NAME("um*")
{
DEF_CA
UCell u1;
UCell u2;
UDCell ud;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
{
#line 678 "./prim"
/* use u* as alias */
#ifdef BUGGY_LONG_LONG
ud = ummul(u1,u2);
#else
ud = (UDCell)u1 * (UDCell)u2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ud=", vm_out); printarg_ud(ud);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_ud2twoCell(ud, sp[1], spTOS);
trace_btb(0 , "um*");
NEXT_P2;}

I_u_m_slash_mod: /* um/mod ( ud u1 -- u2 u3 ) */
/* ud=u3*u1+u2, u1>u2>=0 */
NAME("um/mod")
{
DEF_CA
UDCell ud;
UCell u1;
UCell u2;
UCell u3;
NEXT_P0;
vm_twoCell2ud(ud, (Cell)sp[2], (Cell)sp[1]);
u1 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
sp += 1;
{
#line 696 "./prim"
#ifdef BUGGY_LONG_LONG
UDCell r = umdiv(ud,u1);
u2=r.hi;
u3=r.lo;
#else
u3 = ud/u1;
u2 = ud%u1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_u2Cell(u2);
spTOS = vm_u2Cell(u3);
trace_btb(0 , "um/mod");
NEXT_P2;}

I_m_plus: /* m+ ( d1 n -- d2 ) */
/*  */
NAME("m+")
{
DEF_CA
DCell d1;
Cell n;
DCell d2;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[2], (Cell)sp[1]);
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 715 "./prim"
#ifdef BUGGY_LONG_LONG
d2.lo = d1.lo+n;
d2.hi = d1.hi - (n<0) + (d2.lo<d1.lo);
#else
d2 = d1+n;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS);
trace_btb(0 , "m+");
NEXT_P2;}

I_d_plus: /* d+ ( d1 d2 -- d ) */
/*  */
NAME("d+")
{
DEF_CA
DCell d1;
DCell d2;
DCell d;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 2;
{
#line 725 "./prim"
#ifdef BUGGY_LONG_LONG
d.lo = d1.lo+d2.lo;
d.hi = d1.hi + d2.hi + (d.lo<d1.lo);
#else
d = d1+d2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS);
trace_btb(0 , "d+");
NEXT_P2;}

I_d_minus: /* d- ( d1 d2 -- d ) */
/*  */
NAME("d-")
{
DEF_CA
DCell d1;
DCell d2;
DCell d;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 2;
{
#line 735 "./prim"
#ifdef BUGGY_LONG_LONG
d.lo = d1.lo - d2.lo;
d.hi = d1.hi-d2.hi-(d1.lo<d2.lo);
#else
d = d1-d2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS);
trace_btb(0 , "d-");
NEXT_P2;}

I_d_negate: /* dnegate ( d1 -- d2 ) */
/*  */
NAME("dnegate")
{
DEF_CA
DCell d1;
DCell d2;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
{
#line 745 "./prim"
/* use dminus as alias */
#ifdef BUGGY_LONG_LONG
d2 = dnegate(d1);
#else
d2 = -d1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS);
trace_btb(0 , "dnegate");
NEXT_P2;}

I_d_two_star: /* d2* ( d1 -- d2 ) */
/* Shift left by 1; also works on unsigned numbers */
NAME("d2*")
{
DEF_CA
DCell d1;
DCell d2;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
{
#line 756 "./prim"
#ifdef BUGGY_LONG_LONG
d2.lo = d1.lo<<1;
d2.hi = (d1.hi<<1) | (d1.lo>>(CELL_BITS-1));
#else
d2 = 2*d1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS);
trace_btb(0 , "d2*");
NEXT_P2;}

I_d_two_slash: /* d2/ ( d1 -- d2 ) */
/* Arithmetic shift right by 1.  For signed numbers this is a floored
division by 2. */
NAME("d2/")
{
DEF_CA
DCell d1;
DCell d2;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
{
#line 768 "./prim"
#ifdef BUGGY_LONG_LONG
d2.hi = d1.hi>>1;
d2.lo= (d1.lo>>1) | (d1.hi<<(CELL_BITS-1));
#else
d2 = d1>>1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS);
trace_btb(0 , "d2/");
NEXT_P2;}

I_and: /* and ( w1 w2 -- w ) */
/*  */
NAME("and")
{
DEF_CA
Cell w1;
Cell w2;
Cell w;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 779 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "and");
NEXT_P2;}

I_or: /* or ( w1 w2 -- w ) */
/*  */
NAME("or")
{
DEF_CA
Cell w1;
Cell w2;
Cell w;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 782 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "or");
NEXT_P2;}

I_x_or: /* xor ( w1 w2 -- w ) */
/*  */
NAME("xor")
{
DEF_CA
Cell w1;
Cell w2;
Cell w;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 787 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "xor");
NEXT_P2;}

I_invert: /* invert ( w1 -- w2 ) */
/*  */
NAME("invert")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
}
#endif
{
#line 790 "./prim"
w2 = ~w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w2);
trace_btb(0 , "invert");
NEXT_P2;}

I_r_shift: /* rshift ( u1 n -- u2 ) */
/* Logical shift right by @i{n} bits. */
NAME("rshift")
{
DEF_CA
UCell u1;
Cell n;
UCell u2;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 796 "./prim"
  u2 = u1>>n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(u2);
trace_btb(0 , "rshift");
NEXT_P2;}

I_l_shift: /* lshift ( u1 n -- u2 ) */
/*  */
NAME("lshift")
{
DEF_CA
UCell u1;
Cell n;
UCell u2;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 801 "./prim"
  u2 = u1<<n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(u2);
trace_btb(0 , "lshift");
NEXT_P2;}

I_zero_equals: /* 0= ( n -- f ) */
/*  */
NAME("0=")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 856 "./prim"
f = FLAG(n==0);
#line 856
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "0=");
NEXT_P2;}

I_zero_not_equals: /* 0<> ( n -- f ) */
/*  */
NAME("0<>")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 856 "./prim"
f = FLAG(n!=0);
#line 856
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "0<>");
NEXT_P2;}

I_zero_less_than: /* 0< ( n -- f ) */
/*  */
NAME("0<")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 856 "./prim"
f = FLAG(n<0);
#line 856
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "0<");
NEXT_P2;}

I_zero_greater_than: /* 0> ( n -- f ) */
/*  */
NAME("0>")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 856 "./prim"
f = FLAG(n>0);
#line 856
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "0>");
NEXT_P2;}

I_zero_less_or_equal: /* 0<= ( n -- f ) */
/*  */
NAME("0<=")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 856 "./prim"
f = FLAG(n<=0);
#line 856
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "0<=");
NEXT_P2;}

I_zero_greater_or_equal: /* 0>= ( n -- f ) */
/*  */
NAME("0>=")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 856 "./prim"
f = FLAG(n>=0);
#line 856
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "0>=");
NEXT_P2;}

I_equals: /* = ( n1 n2 -- f ) */
/*  */
NAME("=")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 857 "./prim"
f = FLAG(n1==n2);
#line 857
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "=");
NEXT_P2;}

I_not_equals: /* <> ( n1 n2 -- f ) */
/*  */
NAME("<>")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 857 "./prim"
f = FLAG(n1!=n2);
#line 857
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "<>");
NEXT_P2;}

I_less_than: /* < ( n1 n2 -- f ) */
/*  */
NAME("<")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 857 "./prim"
f = FLAG(n1<n2);
#line 857
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "<");
NEXT_P2;}

I_greater_than: /* > ( n1 n2 -- f ) */
/*  */
NAME(">")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 857 "./prim"
f = FLAG(n1>n2);
#line 857
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , ">");
NEXT_P2;}

I_less_or_equal: /* <= ( n1 n2 -- f ) */
/*  */
NAME("<=")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 857 "./prim"
f = FLAG(n1<=n2);
#line 857
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "<=");
NEXT_P2;}

I_greater_or_equal: /* >= ( n1 n2 -- f ) */
/*  */
NAME(">=")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
n1 = vm_Cell2n(sp[1]);
n2 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 857 "./prim"
f = FLAG(n1>=n2);
#line 857
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , ">=");
NEXT_P2;}

I_u_equals: /* u= ( u1 u2 -- f ) */
/*  */
NAME("u=")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 858 "./prim"
f = FLAG(u1==u2);
#line 858
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "u=");
NEXT_P2;}

I_u_not_equals: /* u<> ( u1 u2 -- f ) */
/*  */
NAME("u<>")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 858 "./prim"
f = FLAG(u1!=u2);
#line 858
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "u<>");
NEXT_P2;}

I_u_less_than: /* u< ( u1 u2 -- f ) */
/*  */
NAME("u<")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 858 "./prim"
f = FLAG(u1<u2);
#line 858
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "u<");
NEXT_P2;}

I_u_greater_than: /* u> ( u1 u2 -- f ) */
/*  */
NAME("u>")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 858 "./prim"
f = FLAG(u1>u2);
#line 858
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "u>");
NEXT_P2;}

I_u_less_or_equal: /* u<= ( u1 u2 -- f ) */
/*  */
NAME("u<=")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 858 "./prim"
f = FLAG(u1<=u2);
#line 858
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "u<=");
NEXT_P2;}

I_u_greater_or_equal: /* u>= ( u1 u2 -- f ) */
/*  */
NAME("u>=")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 858 "./prim"
f = FLAG(u1>=u2);
#line 858
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "u>=");
NEXT_P2;}

#ifdef HAS_DCOMPS
I_d_equals: /* d= ( d1 d2 -- f ) */
/*  */
NAME("d=")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 908 "./prim"
#ifdef BUGGY_LONG_LONG
#line 908
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 908
#else
#line 908
f = FLAG(d1==d2);
#line 908
#endif
#line 908
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d=");
NEXT_P2;}

I_d_not_equals: /* d<> ( d1 d2 -- f ) */
/*  */
NAME("d<>")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 908 "./prim"
#ifdef BUGGY_LONG_LONG
#line 908
f = FLAG(d1.lo!=d2.lo || d1.hi!=d2.hi);
#line 908
#else
#line 908
f = FLAG(d1!=d2);
#line 908
#endif
#line 908
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d<>");
NEXT_P2;}

I_d_less_than: /* d< ( d1 d2 -- f ) */
/*  */
NAME("d<")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 908 "./prim"
#ifdef BUGGY_LONG_LONG
#line 908
f = FLAG(d1.hi==d2.hi ? d1.lo<d2.lo : d1.hi<d2.hi);
#line 908
#else
#line 908
f = FLAG(d1<d2);
#line 908
#endif
#line 908
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d<");
NEXT_P2;}

I_d_greater_than: /* d> ( d1 d2 -- f ) */
/*  */
NAME("d>")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 908 "./prim"
#ifdef BUGGY_LONG_LONG
#line 908
f = FLAG(d1.hi==d2.hi ? d1.lo>d2.lo : d1.hi>d2.hi);
#line 908
#else
#line 908
f = FLAG(d1>d2);
#line 908
#endif
#line 908
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d>");
NEXT_P2;}

I_d_less_or_equal: /* d<= ( d1 d2 -- f ) */
/*  */
NAME("d<=")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 908 "./prim"
#ifdef BUGGY_LONG_LONG
#line 908
f = FLAG(d1.hi==d2.hi ? d1.lo<=d2.lo : d1.hi<=d2.hi);
#line 908
#else
#line 908
f = FLAG(d1<=d2);
#line 908
#endif
#line 908
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d<=");
NEXT_P2;}

I_d_greater_or_equal: /* d>= ( d1 d2 -- f ) */
/*  */
NAME("d>=")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d(d1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2d(d2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 908 "./prim"
#ifdef BUGGY_LONG_LONG
#line 908
f = FLAG(d1.hi==d2.hi ? d1.lo>=d2.lo : d1.hi>=d2.hi);
#line 908
#else
#line 908
f = FLAG(d1>=d2);
#line 908
#endif
#line 908
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d>=");
NEXT_P2;}

I_d_zero_equals: /* d0= ( d -- f ) */
/*  */
NAME("d0=")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d(d, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 909 "./prim"
#ifdef BUGGY_LONG_LONG
#line 909
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 909
#else
#line 909
f = FLAG(d==DZERO);
#line 909
#endif
#line 909
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d0=");
NEXT_P2;}

I_d_zero_not_equals: /* d0<> ( d -- f ) */
/*  */
NAME("d0<>")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d(d, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 909 "./prim"
#ifdef BUGGY_LONG_LONG
#line 909
f = FLAG(d.lo!=DZERO.lo || d.hi!=DZERO.hi);
#line 909
#else
#line 909
f = FLAG(d!=DZERO);
#line 909
#endif
#line 909
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d0<>");
NEXT_P2;}

I_d_zero_less_than: /* d0< ( d -- f ) */
/*  */
NAME("d0<")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d(d, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 909 "./prim"
#ifdef BUGGY_LONG_LONG
#line 909
f = FLAG(d.hi==DZERO.hi ? d.lo<DZERO.lo : d.hi<DZERO.hi);
#line 909
#else
#line 909
f = FLAG(d<DZERO);
#line 909
#endif
#line 909
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d0<");
NEXT_P2;}

I_d_zero_greater_than: /* d0> ( d -- f ) */
/*  */
NAME("d0>")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d(d, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 909 "./prim"
#ifdef BUGGY_LONG_LONG
#line 909
f = FLAG(d.hi==DZERO.hi ? d.lo>DZERO.lo : d.hi>DZERO.hi);
#line 909
#else
#line 909
f = FLAG(d>DZERO);
#line 909
#endif
#line 909
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d0>");
NEXT_P2;}

I_d_zero_less_or_equal: /* d0<= ( d -- f ) */
/*  */
NAME("d0<=")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d(d, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 909 "./prim"
#ifdef BUGGY_LONG_LONG
#line 909
f = FLAG(d.hi==DZERO.hi ? d.lo<=DZERO.lo : d.hi<=DZERO.hi);
#line 909
#else
#line 909
f = FLAG(d<=DZERO);
#line 909
#endif
#line 909
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d0<=");
NEXT_P2;}

I_d_zero_greater_or_equal: /* d0>= ( d -- f ) */
/*  */
NAME("d0>=")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d(d, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 909 "./prim"
#ifdef BUGGY_LONG_LONG
#line 909
f = FLAG(d.hi==DZERO.hi ? d.lo>=DZERO.lo : d.hi>=DZERO.hi);
#line 909
#else
#line 909
f = FLAG(d>=DZERO);
#line 909
#endif
#line 909
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "d0>=");
NEXT_P2;}

I_d_u_equals: /* du= ( ud1 ud2 -- f ) */
/*  */
NAME("du=")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud(ud1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2ud(ud2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 910 "./prim"
#ifdef BUGGY_LONG_LONG
#line 910
f = FLAG(ud1.lo==ud2.lo && ud1.hi==ud2.hi);
#line 910
#else
#line 910
f = FLAG(ud1==ud2);
#line 910
#endif
#line 910
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "du=");
NEXT_P2;}

I_d_u_not_equals: /* du<> ( ud1 ud2 -- f ) */
/*  */
NAME("du<>")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud(ud1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2ud(ud2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 910 "./prim"
#ifdef BUGGY_LONG_LONG
#line 910
f = FLAG(ud1.lo!=ud2.lo || ud1.hi!=ud2.hi);
#line 910
#else
#line 910
f = FLAG(ud1!=ud2);
#line 910
#endif
#line 910
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "du<>");
NEXT_P2;}

I_d_u_less_than: /* du< ( ud1 ud2 -- f ) */
/*  */
NAME("du<")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud(ud1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2ud(ud2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 910 "./prim"
#ifdef BUGGY_LONG_LONG
#line 910
f = FLAG(ud1.hi==ud2.hi ? ud1.lo<ud2.lo : ud1.hi<ud2.hi);
#line 910
#else
#line 910
f = FLAG(ud1<ud2);
#line 910
#endif
#line 910
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "du<");
NEXT_P2;}

I_d_u_greater_than: /* du> ( ud1 ud2 -- f ) */
/*  */
NAME("du>")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud(ud1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2ud(ud2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 910 "./prim"
#ifdef BUGGY_LONG_LONG
#line 910
f = FLAG(ud1.hi==ud2.hi ? ud1.lo>ud2.lo : ud1.hi>ud2.hi);
#line 910
#else
#line 910
f = FLAG(ud1>ud2);
#line 910
#endif
#line 910
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "du>");
NEXT_P2;}

I_d_u_less_or_equal: /* du<= ( ud1 ud2 -- f ) */
/*  */
NAME("du<=")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud(ud1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2ud(ud2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 910 "./prim"
#ifdef BUGGY_LONG_LONG
#line 910
f = FLAG(ud1.hi==ud2.hi ? ud1.lo<=ud2.lo : ud1.hi<=ud2.hi);
#line 910
#else
#line 910
f = FLAG(ud1<=ud2);
#line 910
#endif
#line 910
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "du<=");
NEXT_P2;}

I_d_u_greater_or_equal: /* du>= ( ud1 ud2 -- f ) */
/*  */
NAME("du>=")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud(ud1, (Cell)sp[3], (Cell)sp[2]);
vm_twoCell2ud(ud2, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 910 "./prim"
#ifdef BUGGY_LONG_LONG
#line 910
f = FLAG(ud1.hi==ud2.hi ? ud1.lo>=ud2.lo : ud1.hi>=ud2.hi);
#line 910
#else
#line 910
f = FLAG(ud1>=ud2);
#line 910
#endif
#line 910
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "du>=");
NEXT_P2;}

#endif
I_within: /* within ( u1 u2 u3 -- f ) */
/* u2=<u1<u3 or: u3=<u2 and u1 is not in [u3,u2).  This works for
unsigned and signed numbers (but not a mixture).  Another way to think
about this word is to consider the numbers as a circle (wrapping
around from @code{max-u} to 0 for unsigned, and from @code{max-n} to
min-n for signed numbers); now consider the range from u2 towards
increasing numbers up to and excluding u3 (giving an empty range if
u2=u3); if u1 is in this range, @code{within} returns true. */
NAME("within")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
Bool f;
NEXT_P0;
u1 = vm_Cell2u(sp[2]);
u2 = vm_Cell2u(sp[1]);
u3 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
}
#endif
sp += 2;
{
#line 922 "./prim"
f = FLAG(u1-u2 < u3-u2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
trace_btb(0 , "within");
NEXT_P2;}

GROUP( internal)
I_sp_fetch: /* sp@ ( -- a_addr ) */
/*  */
NAME("sp@")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 929 "./prim"
a_addr = sp+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_a_2Cell(a_addr);
trace_btb(0 , "sp@");
NEXT_P2;}

I_sp_store: /* sp! ( a_addr -- ) */
/*  */
NAME("sp!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 932 "./prim"
sp = a_addr;
/* works with and without spTOS caching */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "sp!");
NEXT_P2;}

I_rp_fetch: /* rp@ ( -- a_addr ) */
/*  */
NAME("rp@")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 936 "./prim"
a_addr = rp;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_a_2Cell(a_addr);
trace_btb(0 , "rp@");
NEXT_P2;}

I_rp_store: /* rp! ( a_addr -- ) */
/*  */
NAME("rp!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 939 "./prim"
rp = a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "rp!");
NEXT_P2;}

#ifdef HAS_FLOATING
I_fp_fetch: /* fp@ ( -- f_addr ) */
/*  */
NAME("fp@")
{
DEF_CA
Float * f_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 944 "./prim"
f_addr = fp;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f_addr=", vm_out); printarg_f_(f_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f_2Cell(f_addr);
trace_btb(0 , "fp@");
NEXT_P2;}

I_fp_store: /* fp! ( f_addr -- ) */
/*  */
NAME("fp!")
{
DEF_CA
Float * f_addr;
NEXT_P0;
f_addr = vm_Cell2f_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr=", vm_out); printarg_f_(f_addr);
}
#endif
sp += 1;
{
#line 947 "./prim"
fp = f_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fp!");
NEXT_P2;}

#endif
I_semis: /* ;s ( R:w -- ) */
/* The primitive compiled by @code{EXIT}. */
NAME(";s")
{
DEF_CA
Cell w;
NEXT_P0;
w = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
rp += 1;
{
#line 953 "./prim"
SET_IP((Xt *)w);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
trace_btb(0 , ";s");
NEXT_P2;}

GROUP( stack)
I_to_r: /* >r ( w -- R:w ) */
/*  */
NAME(">r")
{
DEF_CA
Cell w;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
w = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
rp += -1;
{
#line 958 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_w2Cell(w);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , ">r");
NEXT_P2;}

I_r_from: /* r> ( R:w -- w ) */
/*  */
NAME("r>")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
w = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += -1;
rp += 1;
{
#line 963 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
IF_rpTOS(rpTOS = rp[0]);
trace_btb(0 , "r>");
NEXT_P2;}

I_rdrop: /* rdrop ( R:w -- ) */
/*  */
NAME("rdrop")
{
DEF_CA
Cell w;
NEXT_P0;
w = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
rp += 1;
{
#line 968 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
trace_btb(0 , "rdrop");
NEXT_P2;}

I_two_to_r: /* 2>r ( w1 w2 -- R:w1 R:w2 ) */
/*  */
NAME("2>r")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 2;
rp += -2;
{
#line 972 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
rp[1] = vm_w2Cell(w1);
rpTOS = vm_w2Cell(w2);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "2>r");
NEXT_P2;}

I_two_r_from: /* 2r> ( R:w1 R:w2 -- w1 w2 ) */
/*  */
NAME("2r>")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
w1 = vm_Cell2w(rp[1]);
w2 = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -2;
rp += 2;
{
#line 976 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
IF_rpTOS(rpTOS = rp[0]);
trace_btb(0 , "2r>");
NEXT_P2;}

I_two_r_fetch: /* 2r@ ( R:w1 R:w2 -- R:w1 R:w2 w1 w2 ) */
/*  */
NAME("2r@")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
w1 = vm_Cell2w(rp[1]);
w2 = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -2;
{
#line 980 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "2r@");
NEXT_P2;}

I_two_r_drop: /* 2rdrop ( R:w1 R:w2 -- ) */
/*  */
NAME("2rdrop")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(rp[1]);
w2 = vm_Cell2w(rpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
rp += 2;
{
#line 984 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
trace_btb(0 , "2rdrop");
NEXT_P2;}

I_over: /* over ( w1 w2 -- w1 w2 w1 ) */
/*  */
NAME("over")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -1;
{
#line 988 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(sp[1] = vm_w2Cell(w2););
spTOS = vm_w2Cell(w1);
trace_btb(0 , "over");
NEXT_P2;}

I_drop: /* drop ( w -- ) */
/*  */
NAME("drop")
{
DEF_CA
Cell w;
NEXT_P0;
w = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
{
#line 992 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "drop");
NEXT_P2;}

I_swap: /* swap ( w1 w2 -- w2 w1 ) */
/*  */
NAME("swap")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 996 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(w2);
spTOS = vm_w2Cell(w1);
trace_btb(0 , "swap");
NEXT_P2;}

I_dupe: /* dup ( w -- w w ) */
/*  */
NAME("dup")
{
DEF_CA
Cell w;
NEXT_P0;
w = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += -1;
{
#line 1001 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(sp[1] = vm_w2Cell(w););
spTOS = vm_w2Cell(w);
trace_btb(0 , "dup");
NEXT_P2;}

I_rote: /* rot ( w1 w2 w3 -- w2 w3 w1 ) */
/*  */
NAME("rot")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
NEXT_P0;
w1 = vm_Cell2w(sp[2]);
w2 = vm_Cell2w(sp[1]);
w3 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 1005 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[2] = vm_w2Cell(w2);
sp[1] = vm_w2Cell(w3);
spTOS = vm_w2Cell(w1);
trace_btb(0 , "rot");
NEXT_P2;}

I_not_rote: /* -rot ( w1 w2 w3 -- w3 w1 w2 ) */
/*  */
NAME("-rot")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
NEXT_P0;
w1 = vm_Cell2w(sp[2]);
w2 = vm_Cell2w(sp[1]);
w3 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 1014 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[2] = vm_w2Cell(w3);
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "-rot");
NEXT_P2;}

I_nip: /* nip ( w1 w2 -- w2 ) */
/*  */
NAME("nip")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 1018 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w2);
trace_btb(0 , "nip");
NEXT_P2;}

I_tuck: /* tuck ( w1 w2 -- w2 w1 w2 ) */
/*  */
NAME("tuck")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -1;
{
#line 1022 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[2] = vm_w2Cell(w2);
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "tuck");
NEXT_P2;}

I_question_dupe: /* ?dup ( w -- w ) */
/* Actually the stack effect is: @code{( w -- 0 | w w )}.  It performs a
@code{dup} if w is nonzero. */
NAME("?dup")
{
DEF_CA
Cell w;
NEXT_P0;
w = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 1028 "./prim"
if (w!=0) {
  IF_spTOS(*sp-- = w;)
#ifndef USE_TOS
  *--sp = w;
#endif
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "?dup");
NEXT_P2;}

I_pick: /* pick ( u -- w ) */
/* Actually the stack effect is @code{ x0 ... xu u -- x0 ... xu x0 }. */
NAME("pick")
{
DEF_CA
UCell u;
Cell w;
NEXT_P0;
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1039 "./prim"
w = sp[u+1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "pick");
NEXT_P2;}

I_two_drop: /* 2drop ( w1 w2 -- ) */
/*  */
NAME("2drop")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 2;
{
#line 1044 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "2drop");
NEXT_P2;}

I_two_dupe: /* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
/*  */
NAME("2dup")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
w1 = vm_Cell2w(sp[1]);
w2 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -2;
{
#line 1048 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(sp[2] = vm_w2Cell(w2););
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "2dup");
NEXT_P2;}

I_two_over: /* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
/*  */
NAME("2over")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
w1 = vm_Cell2w(sp[3]);
w2 = vm_Cell2w(sp[2]);
w3 = vm_Cell2w(sp[1]);
w4 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
sp += -2;
{
#line 1052 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(sp[2] = vm_w2Cell(w4););
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "2over");
NEXT_P2;}

I_two_swap: /* 2swap ( w1 w2 w3 w4 -- w3 w4 w1 w2 ) */
/*  */
NAME("2swap")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
w1 = vm_Cell2w(sp[3]);
w2 = vm_Cell2w(sp[2]);
w3 = vm_Cell2w(sp[1]);
w4 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 1056 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[3] = vm_w2Cell(w3);
sp[2] = vm_w2Cell(w4);
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "2swap");
NEXT_P2;}

I_two_rote: /* 2rot ( w1 w2 w3 w4 w5 w6 -- w3 w4 w5 w6 w1 w2 ) */
/*  */
NAME("2rot")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
Cell w5;
Cell w6;
NEXT_P0;
w1 = vm_Cell2w(sp[5]);
w2 = vm_Cell2w(sp[4]);
w3 = vm_Cell2w(sp[3]);
w4 = vm_Cell2w(sp[2]);
w5 = vm_Cell2w(sp[1]);
w6 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
fputs(" w5=", vm_out); printarg_w(w5);
fputs(" w6=", vm_out); printarg_w(w6);
}
#endif
{
#line 1060 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[5] = vm_w2Cell(w3);
sp[4] = vm_w2Cell(w4);
sp[3] = vm_w2Cell(w5);
sp[2] = vm_w2Cell(w6);
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "2rot");
NEXT_P2;}

I_two_nip: /* 2nip ( w1 w2 w3 w4 -- w3 w4 ) */
/*  */
NAME("2nip")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
w1 = vm_Cell2w(sp[3]);
w2 = vm_Cell2w(sp[2]);
w3 = vm_Cell2w(sp[1]);
w4 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
sp += 2;
{
#line 1064 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(w3);
spTOS = vm_w2Cell(w4);
trace_btb(0 , "2nip");
NEXT_P2;}

I_two_tuck: /* 2tuck ( w1 w2 w3 w4 -- w3 w4 w1 w2 w3 w4 ) */
/*  */
NAME("2tuck")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
w1 = vm_Cell2w(sp[3]);
w2 = vm_Cell2w(sp[2]);
w3 = vm_Cell2w(sp[1]);
w4 = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
sp += -2;
{
#line 1068 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[5] = vm_w2Cell(w3);
sp[4] = vm_w2Cell(w4);
sp[3] = vm_w2Cell(w1);
sp[2] = vm_w2Cell(w2);
sp[1] = vm_w2Cell(w3);
spTOS = vm_w2Cell(w4);
trace_btb(0 , "2tuck");
NEXT_P2;}

I_fetch: /* @ ( a_addr -- w ) */
/* @i{w} is the cell stored at @i{a_addr}. */
NAME("@")
{
DEF_CA
Cell * a_addr;
Cell w;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 1075 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "@");
NEXT_P2;}

I_store: /* ! ( w a_addr -- ) */
/* Store @i{w} into the cell at @i{a-addr}. */
NAME("!")
{
DEF_CA
Cell w;
Cell * a_addr;
NEXT_P0;
w = vm_Cell2w(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1079 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "!");
NEXT_P2;}

I_plus_store: /* +! ( n a_addr -- ) */
/* Add @i{n} to the cell at @i{a-addr}. */
NAME("+!")
{
DEF_CA
Cell n;
Cell * a_addr;
NEXT_P0;
n = vm_Cell2n(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1083 "./prim"
*a_addr += n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "+!");
NEXT_P2;}

I_c_fetch: /* c@ ( c_addr -- c ) */
/* @i{c} is the char stored at @i{c_addr}. */
NAME("c@")
{
DEF_CA
Char * c_addr;
Char c;
NEXT_P0;
c_addr = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 1089 "./prim"
c = *c_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c=", vm_out); printarg_c(c);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_c2Cell(c);
trace_btb(0 , "c@");
NEXT_P2;}

I_c_store: /* c! ( c c_addr -- ) */
/* Store @i{c} into the char at @i{c-addr}. */
NAME("c!")
{
DEF_CA
Char c;
Char * c_addr;
NEXT_P0;
c = vm_Cell2c(sp[1]);
c_addr = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c=", vm_out); printarg_c(c);
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
sp += 2;
{
#line 1115 "./prim"
*c_addr = c;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "c!");
NEXT_P2;}

I_two_store: /* 2! ( w1 w2 a_addr -- ) */
/* Store @i{w2} into the cell at @i{c-addr} and @i{w1} into the next cell. */
NAME("2!")
{
DEF_CA
Cell w1;
Cell w2;
Cell * a_addr;
NEXT_P0;
w1 = vm_Cell2w(sp[2]);
w2 = vm_Cell2w(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 3;
{
#line 1145 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "2!");
NEXT_P2;}

I_two_fetch: /* 2@ ( a_addr -- w1 w2 ) */
/* @i{w2} is the content of the cell stored at @i{a-addr}, @i{w1} is
the content of the next cell. */
NAME("2@")
{
DEF_CA
Cell * a_addr;
Cell w1;
Cell w2;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += -1;
{
#line 1153 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(w1);
spTOS = vm_w2Cell(w2);
trace_btb(0 , "2@");
NEXT_P2;}

I_cell_plus: /* cell+ ( a_addr1 -- a_addr2 ) */
/* @code{1 cells +} */
NAME("cell+")
{
DEF_CA
Cell * a_addr1;
Cell * a_addr2;
NEXT_P0;
a_addr1 = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr1=", vm_out); printarg_a_(a_addr1);
}
#endif
{
#line 1160 "./prim"
a_addr2 = a_addr1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr2=", vm_out); printarg_a_(a_addr2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_a_2Cell(a_addr2);
trace_btb(0 , "cell+");
NEXT_P2;}

I_cells: /* cells ( n1 -- n2 ) */
/*  @i{n2} is the number of address units of @i{n1} cells. */
NAME("cells")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1166 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "cells");
NEXT_P2;}

I_char_plus: /* char+ ( c_addr1 -- c_addr2 ) */
/* @code{1 chars +}. */
NAME("char+")
{
DEF_CA
Char * c_addr1;
Char * c_addr2;
NEXT_P0;
c_addr1 = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
}
#endif
{
#line 1177 "./prim"
c_addr2 = c_addr1 + 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_c_2Cell(c_addr2);
trace_btb(0 , "char+");
NEXT_P2;}

I_paren_chars: /* (chars) ( n1 -- n2 ) */
/*  */
NAME("(chars)")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1182 "./prim"
n2 = n1 * sizeof(Char);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "(chars)");
NEXT_P2;}

I_count: /* count ( c_addr1 -- c_addr2 u ) */
/* @i{c-addr2} is the first character and @i{u} the length of the
counted string at @i{c-addr1}. */
NAME("count")
{
DEF_CA
Char * c_addr1;
Char * c_addr2;
UCell u;
NEXT_P0;
c_addr1 = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
}
#endif
sp += -1;
{
#line 1189 "./prim"
u = *c_addr1;
c_addr2 = c_addr1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_c_2Cell(c_addr2);
spTOS = vm_u2Cell(u);
trace_btb(0 , "count");
NEXT_P2;}

I_paren_f83find: /* (f83find) ( c_addr u f83name1 -- f83name2 ) */
/*  */
NAME("(f83find)")
{
DEF_CA
Char * c_addr;
UCell u;
struct F83Name * f83name1;
struct F83Name * f83name2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
f83name1 = vm_Cell2f83name(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" f83name1=", vm_out); printarg_f83name(f83name1);
}
#endif
sp += 2;
{
#line 1195 "./prim"
for (; f83name1 != NULL; f83name1 = (struct F83Name *)(f83name1->next))
  if ((UCell)F83NAME_COUNT(f83name1)==u &&
      memcasecmp(c_addr, f83name1->name, u)== 0 /* or inline? */)
    break;
f83name2=f83name1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f83name2=", vm_out); printarg_f83name(f83name2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f83name2Cell(f83name2);
trace_btb(0 , "(f83find)");
NEXT_P2;}

#ifdef HAS_HASH
I_paren_hashfind: /* (hashfind) ( c_addr u a_addr -- f83name2 ) */
/*  */
NAME("(hashfind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct F83Name * f83name2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1212 "./prim"
struct F83Name *f83name1;
f83name2=NULL;
while(a_addr != NULL)
{
   f83name1=(struct F83Name *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)F83NAME_COUNT(f83name1)==u &&
       memcasecmp(c_addr, f83name1->name, u)== 0 /* or inline? */)
     {
	f83name2=f83name1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f83name2=", vm_out); printarg_f83name(f83name2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f83name2Cell(f83name2);
trace_btb(0 , "(hashfind)");
NEXT_P2;}

I_paren_tablefind: /* (tablefind) ( c_addr u a_addr -- f83name2 ) */
/* A case-sensitive variant of @code{(hashfind)} */
NAME("(tablefind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct F83Name * f83name2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1235 "./prim"
struct F83Name *f83name1;
f83name2=NULL;
while(a_addr != NULL)
{
   f83name1=(struct F83Name *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)F83NAME_COUNT(f83name1)==u &&
       memcmp(c_addr, f83name1->name, u)== 0 /* or inline? */)
     {
	f83name2=f83name1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f83name2=", vm_out); printarg_f83name(f83name2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f83name2Cell(f83name2);
trace_btb(0 , "(tablefind)");
NEXT_P2;}

I_paren_hashkey: /* (hashkey) ( c_addr u1 -- u2 ) */
/*  */
NAME("(hashkey)")
{
DEF_CA
Char * c_addr;
UCell u1;
UCell u2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u1 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
sp += 1;
{
#line 1257 "./prim"
u2=0;
while(u1--)
   u2+=(Cell)toupper(*c_addr++);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(u2);
trace_btb(0 , "(hashkey)");
NEXT_P2;}

I_paren_hashkey1: /* (hashkey1) ( c_addr u ubits -- ukey ) */
/* ukey is the hash key for the string c_addr u fitting in ubits bits */
NAME("(hashkey1)")
{
DEF_CA
Char * c_addr;
UCell u;
UCell ubits;
UCell ukey;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
ubits = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" ubits=", vm_out); printarg_u(ubits);
}
#endif
sp += 2;
{
#line 1265 "./prim"
/* this hash function rotates the key at every step by rot bits within
   ubits bits and xors it with the character. This function does ok in
   the chi-sqare-test.  Rot should be <=7 (preferably <=5) for
   ASCII strings (larger if ubits is large), and should share no
   divisors with ubits.
*/
unsigned rot = ((char []){5,0,1,2,3,4,5,5,5,5,3,5,5,5,5,7,5,5,5,5,7,5,5,5,5,6,5,5,5,5,7,5,5})[ubits];
Char *cp = c_addr;
for (ukey=0; cp<c_addr+u; cp++)
    ukey = ((((ukey<<rot) | (ukey>>(ubits-rot))) 
	     ^ toupper(*cp))
	    & ((1<<ubits)-1));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ukey=", vm_out); printarg_u(ukey);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(ukey);
trace_btb(0 , "(hashkey1)");
NEXT_P2;}

#endif
I_paren_parse_white: /* (parse-white) ( c_addr1 u1 -- c_addr2 u2 ) */
/*  */
NAME("(parse-white)")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[1]);
u1 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
{
#line 1293 "./prim"
/* use !isgraph instead of isspace? */
Char *endp = c_addr1+u1;
while (c_addr1<endp && isspace(*c_addr1))
  c_addr1++;
if (c_addr1<endp) {
  for (c_addr2 = c_addr1; c_addr1<endp && !isspace(*c_addr1); c_addr1++)
    ;
  u2 = c_addr1-c_addr2;
}
else {
  c_addr2 = c_addr1;
  u2 = 0;
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_c_2Cell(c_addr2);
spTOS = vm_u2Cell(u2);
trace_btb(0 , "(parse-white)");
NEXT_P2;}

I_aligned: /* aligned ( c_addr -- a_addr ) */
/*  @i{a-addr} is the first aligned address greater than or equal to @i{c-addr}. */
NAME("aligned")
{
DEF_CA
Char * c_addr;
Cell * a_addr;
NEXT_P0;
c_addr = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 1314 "./prim"
a_addr = (Cell *)((((Cell)c_addr)+(sizeof(Cell)-1))&(-sizeof(Cell)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_a_2Cell(a_addr);
trace_btb(0 , "aligned");
NEXT_P2;}

I_f_aligned: /* faligned ( c_addr -- f_addr ) */
/*  @i{f-addr} is the first float-aligned address greater than or equal to @i{c-addr}. */
NAME("faligned")
{
DEF_CA
Char * c_addr;
Float * f_addr;
NEXT_P0;
c_addr = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 1320 "./prim"
f_addr = (Float *)((((Cell)c_addr)+(sizeof(Float)-1))&(-sizeof(Float)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f_addr=", vm_out); printarg_f_(f_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f_2Cell(f_addr);
trace_btb(0 , "faligned");
NEXT_P2;}

I_to_body: /* >body ( xt -- a_addr ) */
/*  Get the address of the body of the word represented by @i{xt} (the address
of the word's data field). */
NAME(">body")
{
DEF_CA
Xt xt;
Cell * a_addr;
NEXT_P0;
xt = vm_Cell2xt(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
{
#line 1327 "./prim"
a_addr = PFA(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_a_2Cell(a_addr);
trace_btb(0 , ">body");
NEXT_P2;}

I_to_code_address: /* >code-address ( xt -- c_addr ) */
/* @i{c-addr} is the code address of the word @i{xt}. */
NAME(">code-address")
{
DEF_CA
Xt xt;
Char * c_addr;
NEXT_P0;
xt = vm_Cell2xt(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
{
#line 1336 "./prim"
/* !! This behaves installation-dependently for DOES-words */
c_addr = (Address)CODE_ADDRESS(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_c_2Cell(c_addr);
trace_btb(0 , ">code-address");
NEXT_P2;}

I_to_does_code: /* >does-code ( xt -- a_addr ) */
/* If @i{xt} is the execution token of a child of a @code{DOES>} word,
@i{a-addr} is the start of the Forth code after the @code{DOES>};
Otherwise @i{a-addr} is 0. */
NAME(">does-code")
{
DEF_CA
Xt xt;
Cell * a_addr;
NEXT_P0;
xt = vm_Cell2xt(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
{
#line 1345 "./prim"
a_addr = (Cell *)DOES_CODE(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_a_2Cell(a_addr);
trace_btb(0 , ">does-code");
NEXT_P2;}

I_code_address_store: /* code-address! ( c_addr xt -- ) */
/* Create a code field with code address @i{c-addr} at @i{xt}. */
NAME("code-address!")
{
DEF_CA
Char * c_addr;
Xt xt;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
xt = vm_Cell2xt(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
sp += 2;
{
#line 1351 "./prim"
MAKE_CF(xt, c_addr);
CACHE_FLUSH(xt,(size_t)PFA(0));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "code-address!");
NEXT_P2;}

I_does_code_store: /* does-code! ( a_addr xt -- ) */
/* Create a code field at @i{xt} for a child of a @code{DOES>}-word;
@i{a-addr} is the start of the Forth code after @code{DOES>}. */
NAME("does-code!")
{
DEF_CA
Cell * a_addr;
Xt xt;
NEXT_P0;
a_addr = vm_Cell2a_(sp[1]);
xt = vm_Cell2xt(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
sp += 2;
{
#line 1359 "./prim"
MAKE_DOES_CF(xt, a_addr);
CACHE_FLUSH(xt,(size_t)PFA(0));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "does-code!");
NEXT_P2;}

I_does_handler_store: /* does-handler! ( a_addr -- ) */
/* Create a @code{DOES>}-handler at address @i{a-addr}. Normally,
@i{a-addr} points just behind a @code{DOES>}. */
NAME("does-handler!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 1367 "./prim"
MAKE_DOES_HANDLER(a_addr);
CACHE_FLUSH((caddr_t)a_addr,DOES_HANDLER_SIZE);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "does-handler!");
NEXT_P2;}

I_slash_does_handler: /* /does-handler ( -- n ) */
/* The size of a @code{DOES>}-handler (includes possible padding). */
NAME("/does-handler")
{
DEF_CA
Cell n;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1374 "./prim"
/* !! a constant or environmental query might be better */
n = DOES_HANDLER_SIZE;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "/does-handler");
NEXT_P2;}

I_threading_method: /* threading-method ( -- n ) */
/* 0 if the engine is direct threaded. Note that this may change during
the lifetime of an image. */
NAME("threading-method")
{
DEF_CA
Cell n;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1382 "./prim"
#if defined(DOUBLY_INDIRECT)
n=2;
#else
# if defined(DIRECT_THREADED)
n=0;
# else
n=1;
# endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "threading-method");
NEXT_P2;}

GROUP( hostos)
I_paren_key_file: /* key-file ( wfileid -- n ) */
/*  */
NAME("key-file")
{
DEF_CA
Cell wfileid;
Cell n;
NEXT_P0;
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1399 "./prim"
#ifdef HAS_FILE
fflush(stdout);
n = key((FILE*)wfileid);
#else
n = key(stdin);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "key-file");
NEXT_P2;}

I_key_q_file: /* key?-file ( wfileid -- n ) */
/*  */
NAME("key?-file")
{
DEF_CA
Cell wfileid;
Cell n;
NEXT_P0;
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1407 "./prim"
#ifdef HAS_FILE
fflush(stdout);
n = key_query((FILE*)wfileid);
#else
n = key_query(stdin);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n);
trace_btb(0 , "key?-file");
NEXT_P2;}

#ifdef HAS_OS
I_stdin: /* stdin ( -- wfileid ) */
/*  */
NAME("stdin")
{
DEF_CA
Cell wfileid;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1417 "./prim"
wfileid = (Cell)stdin;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wfileid);
trace_btb(0 , "stdin");
NEXT_P2;}

I_stdout: /* stdout ( -- wfileid ) */
/*  */
NAME("stdout")
{
DEF_CA
Cell wfileid;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1420 "./prim"
wfileid = (Cell)stdout;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wfileid);
trace_btb(0 , "stdout");
NEXT_P2;}

I_stderr: /* stderr ( -- wfileid ) */
/*  */
NAME("stderr")
{
DEF_CA
Cell wfileid;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1423 "./prim"
wfileid = (Cell)stderr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wfileid);
trace_btb(0 , "stderr");
NEXT_P2;}

I_form: /* form ( -- urows ucols ) */
/* The number of lines and columns in the terminal. These numbers may change
with the window size. */
NAME("form")
{
DEF_CA
UCell urows;
UCell ucols;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -2;
{
#line 1428 "./prim"
/* we could block SIGWINCH here to get a consistent size, but I don't
 think this is necessary or always beneficial */
urows=rows;
ucols=cols;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" urows=", vm_out); printarg_u(urows);
fputs(" ucols=", vm_out); printarg_u(ucols);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_u2Cell(urows);
spTOS = vm_u2Cell(ucols);
trace_btb(0 , "form");
NEXT_P2;}

I_flush_icache: /* flush-icache ( c_addr u -- ) */
/* Make sure that the instruction cache of the processor (if there is
one) does not contain stale data at @i{c-addr} and @i{u} bytes
afterwards. @code{END-CODE} performs a @code{flush-icache}
automatically. Caveat: @code{flush-icache} might not work on your
installation; this is usually the case if direct threading is not
supported on your machine (take a look at your @file{machine.h}) and
your machine has a separate instruction cache. In such cases,
@code{flush-icache} does nothing instead of flushing the instruction
cache. */
NAME("flush-icache")
{
DEF_CA
Char * c_addr;
UCell u;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 2;
{
#line 1443 "./prim"
FLUSH_ICACHE(c_addr,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "flush-icache");
NEXT_P2;}

I_paren_bye: /* (bye) ( n -- ) */
/*  */
NAME("(bye)")
{
DEF_CA
Cell n;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 1446 "./prim"
SUPER_END;
return (Label *)n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "(bye)");
NEXT_P2;}

I_peren_system: /* (system) ( c_addr u -- wretval wior ) */
/*  */
NAME("(system)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wretval;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1450 "./prim"
#ifndef MSDOS
int old_tp=terminal_prepped;
deprep_terminal();
#endif
wretval=system(cstr(c_addr,u,1)); /* ~ expansion on first part of string? */
wior = IOR(wretval==-1 || (wretval==127 && errno != 0));
#ifndef MSDOS
if (old_tp)
  prep_terminal();
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wretval=", vm_out); printarg_w(wretval);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(wretval);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "(system)");
NEXT_P2;}

I_getenv: /* getenv ( c_addr1 u1 -- c_addr2 u2 ) */
/* The string @i{c-addr1 u1} specifies an environment variable. The string @i{c-addr2 u2}
is the host operating system's expansion of that environment variable. If the
environment variable does not exist, @i{c-addr2 u2} specifies a string 0 characters
in length. */
NAME("getenv")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[1]);
u1 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
{
#line 1466 "./prim"
/* close ' to keep fontify happy */
c_addr2 = getenv(cstr(c_addr1,u1,1));
u2 = (c_addr2 == NULL ? 0 : strlen(c_addr2));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_c_2Cell(c_addr2);
spTOS = vm_u2Cell(u2);
trace_btb(0 , "getenv");
NEXT_P2;}

I_open_pipe: /* open-pipe ( c_addr u wfam -- wfileid wior ) */
/*  */
NAME("open-pipe")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wfileid;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
wfam = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" wfam=", vm_out); printarg_w(wfam);
}
#endif
sp += 1;
{
#line 1471 "./prim"
wfileid=(Cell)popen(cstr(c_addr,u,1),fileattr[wfam]); /* ~ expansion of 1st arg? */
wior = IOR(wfileid==0); /* !! the man page says that errno is not set reliably */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(wfileid);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "open-pipe");
NEXT_P2;}

I_close_pipe: /* close-pipe ( wfileid -- wretval wior ) */
/*  */
NAME("close-pipe")
{
DEF_CA
Cell wfileid;
Cell wretval;
Cell wior;
NEXT_P0;
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -1;
{
#line 1475 "./prim"
wretval = pclose((FILE *)wfileid);
wior = IOR(wretval==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wretval=", vm_out); printarg_w(wretval);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(wretval);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "close-pipe");
NEXT_P2;}

I_time_and_date: /* time&date ( -- nsec nmin nhour nday nmonth nyear ) */
/* Report the current time of day. Seconds, minutes and hours are numbered from 0.
Months are numbered from 1. */
NAME("time&date")
{
DEF_CA
Cell nsec;
Cell nmin;
Cell nhour;
Cell nday;
Cell nmonth;
Cell nyear;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -6;
{
#line 1481 "./prim"
struct timeval time1;
struct timezone zone1;
struct tm *ltime;
gettimeofday(&time1,&zone1);
/* !! Single Unix specification: 
   If tzp is not a null pointer, the behaviour is unspecified. */
ltime=localtime((time_t *)&time1.tv_sec);
nyear =ltime->tm_year+1900;
nmonth=ltime->tm_mon+1;
nday  =ltime->tm_mday;
nhour =ltime->tm_hour;
nmin  =ltime->tm_min;
nsec  =ltime->tm_sec;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nsec=", vm_out); printarg_n(nsec);
fputs(" nmin=", vm_out); printarg_n(nmin);
fputs(" nhour=", vm_out); printarg_n(nhour);
fputs(" nday=", vm_out); printarg_n(nday);
fputs(" nmonth=", vm_out); printarg_n(nmonth);
fputs(" nyear=", vm_out); printarg_n(nyear);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[5] = vm_n2Cell(nsec);
sp[4] = vm_n2Cell(nmin);
sp[3] = vm_n2Cell(nhour);
sp[2] = vm_n2Cell(nday);
sp[1] = vm_n2Cell(nmonth);
spTOS = vm_n2Cell(nyear);
trace_btb(0 , "time&date");
NEXT_P2;}

I_ms: /* ms ( n -- ) */
/* Wait at least @i{n} milli-second. */
NAME("ms")
{
DEF_CA
Cell n;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 1497 "./prim"
struct timeval timeout;
timeout.tv_sec=n/1000;
timeout.tv_usec=1000*(n%1000);
(void)select(0,0,0,0,&timeout);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "ms");
NEXT_P2;}

I_allocate: /* allocate ( u -- a_addr wior ) */
/* Allocate @i{u} address units of contiguous data space. The initial
contents of the data space is undefined. If the allocation is successful,
@i{a-addr} is the start address of the allocated region and @i{wior}
is 0. If the allocation fails, @i{a-addr} is undefined and @i{wior}
is a non-zero I/O result code. */
NAME("allocate")
{
DEF_CA
UCell u;
Cell * a_addr;
Cell wior;
NEXT_P0;
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += -1;
{
#line 1508 "./prim"
a_addr = (Cell *)malloc(u?u:1);
wior = IOR(a_addr==NULL);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_a_2Cell(a_addr);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "allocate");
NEXT_P2;}

I_free: /* free ( a_addr -- wior ) */
/* Return the region of data space starting at @i{a-addr} to the system.
The region must originally have been obtained using @code{allocate} or
@code{resize}. If the operational is successful, @i{wior} is 0.
If the operation fails, @i{wior} is a non-zero I/O result code. */
NAME("free")
{
DEF_CA
Cell * a_addr;
Cell wior;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 1516 "./prim"
free(a_addr);
wior = 0;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "free");
NEXT_P2;}

I_resize: /* resize ( a_addr1 u -- a_addr2 wior ) */
/* Change the size of the allocated area at @i{a-addr1} to @i{u}
address units, possibly moving the contents to a different
area. @i{a-addr2} is the address of the resulting area.
If the operation is successful, @i{wior} is 0.
If the operation fails, @i{wior} is a non-zero
I/O result code. If @i{a-addr1} is 0, Gforth's (but not the Standard)
@code{resize} @code{allocate}s @i{u} address units. */
NAME("resize")
{
DEF_CA
Cell * a_addr1;
UCell u;
Cell * a_addr2;
Cell wior;
NEXT_P0;
a_addr1 = vm_Cell2a_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr1=", vm_out); printarg_a_(a_addr1);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1527 "./prim"
/* the following check is not necessary on most OSs, but it is needed
   on SunOS 4.1.2. */
/* close ' to keep fontify happy */
if (a_addr1==NULL)
  a_addr2 = (Cell *)malloc(u);
else
  a_addr2 = (Cell *)realloc(a_addr1, u);
wior = IOR(a_addr2==NULL);	/* !! Define a return code */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr2=", vm_out); printarg_a_(a_addr2);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_a_2Cell(a_addr2);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "resize");
NEXT_P2;}

I_strerror: /* strerror ( n -- c_addr u ) */
/*  */
NAME("strerror")
{
DEF_CA
Cell n;
Char * c_addr;
UCell u;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += -1;
{
#line 1537 "./prim"
c_addr = strerror(n);
u = strlen(c_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_c_2Cell(c_addr);
spTOS = vm_u2Cell(u);
trace_btb(0 , "strerror");
NEXT_P2;}

I_strsignal: /* strsignal ( n -- c_addr u ) */
/*  */
NAME("strsignal")
{
DEF_CA
Cell n;
Char * c_addr;
UCell u;
NEXT_P0;
n = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += -1;
{
#line 1541 "./prim"
c_addr = strsignal(n);
u = strlen(c_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_c_2Cell(c_addr);
spTOS = vm_u2Cell(u);
trace_btb(0 , "strsignal");
NEXT_P2;}

I_call_c: /* call-c ( w -- ) */
/* Call the C function pointed to by @i{w}. The C function has to
access the stack itself. The stack pointers are exported in the global
variables @code{SP} and @code{FP}. */
NAME("call-c")
{
DEF_CA
Cell w;
NEXT_P0;
w = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
{
#line 1548 "./prim"
/* This is a first attempt at support for calls to C. This may change in
   the future */
IF_fpTOS(fp[0]=fpTOS);
FP=fp;
SP=sp;
((void (*)())w)();
sp=SP;
fp=FP;
IF_spTOS(spTOS=sp[0]);
IF_fpTOS(fpTOS=fp[0]);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "call-c");
NEXT_P2;}

#endif
#ifdef HAS_FILE
I_close_file: /* close-file ( wfileid -- wior ) */
/*  */
NAME("close-file")
{
DEF_CA
Cell wfileid;
Cell wior;
NEXT_P0;
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1563 "./prim"
wior = IOR(fclose((FILE *)wfileid)==EOF);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "close-file");
NEXT_P2;}

I_open_file: /* open-file ( c_addr u wfam -- wfileid wior ) */
/*  */
NAME("open-file")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wfileid;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
wfam = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" wfam=", vm_out); printarg_w(wfam);
}
#endif
sp += 1;
{
#line 1566 "./prim"
wfileid = (Cell)fopen(tilde_cstr(c_addr, u, 1), fileattr[wfam]);
wior =  IOR(wfileid == 0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(wfileid);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "open-file");
NEXT_P2;}

I_create_file: /* create-file ( c_addr u wfam -- wfileid wior ) */
/*  */
NAME("create-file")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wfileid;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
wfam = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" wfam=", vm_out); printarg_w(wfam);
}
#endif
sp += 1;
{
#line 1570 "./prim"
Cell	fd;
fd = open(tilde_cstr(c_addr, u, 1), O_CREAT|O_TRUNC|ufileattr[wfam], 0666);
if (fd != -1) {
  wfileid = (Cell)fdopen(fd, fileattr[wfam]);
  wior = IOR(wfileid == 0);
} else {
  wfileid = 0;
  wior = IOR(1);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(wfileid);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "create-file");
NEXT_P2;}

I_delete_file: /* delete-file ( c_addr u -- wior ) */
/*  */
NAME("delete-file")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 1581 "./prim"
wior = IOR(unlink(tilde_cstr(c_addr, u, 1))==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "delete-file");
NEXT_P2;}

I_rename_file: /* rename-file ( c_addr1 u1 c_addr2 u2 -- wior ) */
/* Rename file @i{c_addr1 u1} to new name @i{c_addr2 u2} */
NAME("rename-file")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
Cell wior;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[3]);
u1 = vm_Cell2u(sp[2]);
c_addr2 = vm_Cell2c_(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 3;
{
#line 1585 "./prim"
char *s1=tilde_cstr(c_addr2, u2, 1);
wior = IOR(rename(tilde_cstr(c_addr1, u1, 0), s1)==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "rename-file");
NEXT_P2;}

I_file_position: /* file-position ( wfileid -- ud wior ) */
/*  */
NAME("file-position")
{
DEF_CA
Cell wfileid;
UDCell ud;
Cell wior;
NEXT_P0;
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -2;
{
#line 1589 "./prim"
/* !! use tell and lseek? */
ud = LONG2UD(ftell((FILE *)wfileid));
wior = IOR(UD2LONG(ud)==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_ud2twoCell(ud, sp[2], sp[1]);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "file-position");
NEXT_P2;}

I_reposition_file: /* reposition-file ( ud wfileid -- wior ) */
/*  */
NAME("reposition-file")
{
DEF_CA
UDCell ud;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_twoCell2ud(ud, (Cell)sp[2], (Cell)sp[1]);
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 2;
{
#line 1594 "./prim"
wior = IOR(fseek((FILE *)wfileid, UD2LONG(ud), SEEK_SET)==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "reposition-file");
NEXT_P2;}

I_file_size: /* file-size ( wfileid -- ud wior ) */
/*  */
NAME("file-size")
{
DEF_CA
Cell wfileid;
UDCell ud;
Cell wior;
NEXT_P0;
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -2;
{
#line 1597 "./prim"
struct stat buf;
wior = IOR(fstat(fileno((FILE *)wfileid), &buf)==-1);
ud = LONG2UD(buf.st_size);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_ud2twoCell(ud, sp[2], sp[1]);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "file-size");
NEXT_P2;}

I_resize_file: /* resize-file ( ud wfileid -- wior ) */
/*  */
NAME("resize-file")
{
DEF_CA
UDCell ud;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_twoCell2ud(ud, (Cell)sp[2], (Cell)sp[1]);
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 2;
{
#line 1602 "./prim"
wior = IOR(ftruncate(fileno((FILE *)wfileid), UD2LONG(ud))==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "resize-file");
NEXT_P2;}

I_read_file: /* read-file ( c_addr u1 wfileid -- u2 wior ) */
/*  */
NAME("read-file")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
UCell u2;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u1 = vm_Cell2u(sp[1]);
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 1;
{
#line 1605 "./prim"
/* !! fread does not guarantee enough */
u2 = fread(c_addr, sizeof(Char), u1, (FILE *)wfileid);
wior = FILEIO(u2<u1 && ferror((FILE *)wfileid));
/* !! is the value of ferror errno-compatible? */
if (wior)
  clearerr((FILE *)wfileid);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_u2Cell(u2);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "read-file");
NEXT_P2;}

I_read_line: /* read-line ( c_addr u1 wfileid -- u2 flag wior ) */
/* this is only for backward compatibility */
NAME("read-line")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
UCell u2;
Bool flag;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u1 = vm_Cell2u(sp[1]);
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1614 "./prim"
Cell c;
flag=-1;
for(u2=0; u2<u1; u2++)
{
   c = getc((FILE *)wfileid);
   if (c=='\n') break;
   if (c=='\r') {
     if ((c = getc((FILE *)wfileid))!='\n')
       ungetc(c,(FILE *)wfileid);
     break;
   }
   if (c==EOF) {
	flag=FLAG(u2!=0);
	break;
     }
   c_addr[u2] = (Char)c;
}
wior=FILEIO(ferror((FILE *)wfileid));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" flag=", vm_out); printarg_f(flag);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[2] = vm_u2Cell(u2);
sp[1] = vm_f2Cell(flag);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "read-line");
NEXT_P2;}

#endif
I_write_file: /* write-file ( c_addr u1 wfileid -- wior ) */
/*  */
NAME("write-file")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u1 = vm_Cell2u(sp[1]);
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 2;
{
#line 1636 "./prim"
/* !! fwrite does not guarantee enough */
#ifdef HAS_FILE
{
  UCell u2 = fwrite(c_addr, sizeof(Char), u1, (FILE *)wfileid);
  wior = FILEIO(u2<u1 && ferror((FILE *)wfileid));
  if (wior)
    clearerr((FILE *)wfileid);
}
#else
TYPE(c_addr, u1);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "write-file");
NEXT_P2;}

I_emit_file: /* emit-file ( c wfileid -- wior ) */
/*  */
NAME("emit-file")
{
DEF_CA
Char c;
Cell wfileid;
Cell wior;
NEXT_P0;
c = vm_Cell2c(sp[1]);
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c=", vm_out); printarg_c(c);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 1;
{
#line 1649 "./prim"
#ifdef HAS_FILE
wior = FILEIO(putc(c, (FILE *)wfileid)==EOF);
if (wior)
  clearerr((FILE *)wfileid);
#else
PUTC(c);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "emit-file");
NEXT_P2;}

#ifdef HAS_FILE
I_flush_file: /* flush-file ( wfileid -- wior ) */
/*  */
NAME("flush-file")
{
DEF_CA
Cell wfileid;
Cell wior;
NEXT_P0;
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1660 "./prim"
wior = IOR(fflush((FILE *) wfileid)==EOF);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "flush-file");
NEXT_P2;}

I_file_status: /* file-status ( c_addr u -- wfam wior ) */
/*  */
NAME("file-status")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1663 "./prim"
char *filename=tilde_cstr(c_addr, u, 1);
if (access (filename, F_OK) != 0) {
  wfam=0;
  wior=IOR(1);
}
else if (access (filename, R_OK | W_OK) == 0) {
  wfam=2; /* r/w */
  wior=0;
}
else if (access (filename, R_OK) == 0) {
  wfam=0; /* r/o */
  wior=0;
}
else if (access (filename, W_OK) == 0) {
  wfam=4; /* w/o */
  wior=0;
}
else {
  wfam=1; /* well, we cannot access the file, but better deliver a legal
	    access mode (r/o bin), so we get a decent error later upon open. */
  wior=0;
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfam=", vm_out); printarg_w(wfam);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(wfam);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "file-status");
NEXT_P2;}

#endif
#ifdef HAS_FLOATING
GROUP( floating)
I_f_equals: /* f= ( r1 r2 -- f ) */
/*  */
NAME("f=")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1691 "./prim"
f = FLAG(r1==r2);
#line 1691
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f=");
NEXT_P2;}

I_f_not_equals: /* f<> ( r1 r2 -- f ) */
/*  */
NAME("f<>")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1691 "./prim"
f = FLAG(r1!=r2);
#line 1691
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f<>");
NEXT_P2;}

I_f_less_than: /* f< ( r1 r2 -- f ) */
/*  */
NAME("f<")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1691 "./prim"
f = FLAG(r1<r2);
#line 1691
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f<");
NEXT_P2;}

I_f_greater_than: /* f> ( r1 r2 -- f ) */
/*  */
NAME("f>")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1691 "./prim"
f = FLAG(r1>r2);
#line 1691
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f>");
NEXT_P2;}

I_f_less_or_equal: /* f<= ( r1 r2 -- f ) */
/*  */
NAME("f<=")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1691 "./prim"
f = FLAG(r1<=r2);
#line 1691
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f<=");
NEXT_P2;}

I_f_greater_or_equal: /* f>= ( r1 r2 -- f ) */
/*  */
NAME("f>=")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1691 "./prim"
f = FLAG(r1>=r2);
#line 1691
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f>=");
NEXT_P2;}

I_f_zero_equals: /* f0= ( r -- f ) */
/*  */
NAME("f0=")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1692 "./prim"
f = FLAG(r==0.);
#line 1692
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f0=");
NEXT_P2;}

I_f_zero_not_equals: /* f0<> ( r -- f ) */
/*  */
NAME("f0<>")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1692 "./prim"
f = FLAG(r!=0.);
#line 1692
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f0<>");
NEXT_P2;}

I_f_zero_less_than: /* f0< ( r -- f ) */
/*  */
NAME("f0<")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1692 "./prim"
f = FLAG(r<0.);
#line 1692
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f0<");
NEXT_P2;}

I_f_zero_greater_than: /* f0> ( r -- f ) */
/*  */
NAME("f0>")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1692 "./prim"
f = FLAG(r>0.);
#line 1692
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f0>");
NEXT_P2;}

I_f_zero_less_or_equal: /* f0<= ( r -- f ) */
/*  */
NAME("f0<=")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1692 "./prim"
f = FLAG(r<=0.);
#line 1692
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f0<=");
NEXT_P2;}

I_f_zero_greater_or_equal: /* f0>= ( r -- f ) */
/*  */
NAME("f0>=")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1692 "./prim"
f = FLAG(r>=0.);
#line 1692
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(f);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f0>=");
NEXT_P2;}

I_d_to_f: /* d>f ( d -- r ) */
/*  */
NAME("d>f")
{
DEF_CA
DCell d;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_twoCell2d(d, (Cell)sp[1], (Cell)spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 2;
fp += -1;
{
#line 1695 "./prim"
#ifdef BUGGY_LONG_LONG
extern double ldexp(double x, int exp);
r = ldexp((Float)d.hi,CELL_BITS) + (Float)d.lo;
#else
r = d;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "d>f");
NEXT_P2;}

I_f_to_d: /* f>d ( r -- d ) */
/*  */
NAME("f>d")
{
DEF_CA
Float r;
DCell d;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -2;
fp += 1;
{
#line 1703 "./prim"
#ifdef BUGGY_LONG_LONG
d.hi = ldexp(r,-(int)(CELL_BITS)) - (r<0);
d.lo = r-ldexp((Float)d.hi,CELL_BITS);
#else
d = r;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f>d");
NEXT_P2;}

I_f_store: /* f! ( r f_addr -- ) */
/* Store @i{r} into the float at address @i{f-addr}. */
NAME("f!")
{
DEF_CA
Float r;
Float * f_addr;
NEXT_P0;
r = vm_Float2r(fpTOS);
f_addr = vm_Cell2f_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" f_addr=", vm_out); printarg_f_(f_addr);
}
#endif
sp += 1;
fp += 1;
{
#line 1712 "./prim"
*f_addr = r;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f!");
NEXT_P2;}

I_f_fetch: /* f@ ( f_addr -- r ) */
/* @i{r} is the float at address @i{f-addr}. */
NAME("f@")
{
DEF_CA
Float * f_addr;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
f_addr = vm_Cell2f_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr=", vm_out); printarg_f_(f_addr);
}
#endif
sp += 1;
fp += -1;
{
#line 1716 "./prim"
r = *f_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "f@");
NEXT_P2;}

I_d_f_fetch: /* df@ ( df_addr -- r ) */
/* Fetch the double-precision IEEE floating-point value @i{r} from the address @i{df-addr}. */
NAME("df@")
{
DEF_CA
DFloat * df_addr;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
df_addr = vm_Cell2df_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" df_addr=", vm_out); printarg_df_(df_addr);
}
#endif
sp += 1;
fp += -1;
{
#line 1720 "./prim"
#ifdef IEEE_FP
r = *df_addr;
#else
!! df@
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "df@");
NEXT_P2;}

I_d_f_store: /* df! ( r df_addr -- ) */
/* Store @i{r} as double-precision IEEE floating-point value to the
address @i{df-addr}. */
NAME("df!")
{
DEF_CA
Float r;
DFloat * df_addr;
NEXT_P0;
r = vm_Float2r(fpTOS);
df_addr = vm_Cell2df_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" df_addr=", vm_out); printarg_df_(df_addr);
}
#endif
sp += 1;
fp += 1;
{
#line 1729 "./prim"
#ifdef IEEE_FP
*df_addr = r;
#else
!! df!
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "df!");
NEXT_P2;}

I_s_f_fetch: /* sf@ ( sf_addr -- r ) */
/* Fetch the single-precision IEEE floating-point value @i{r} from the address @i{sf-addr}. */
NAME("sf@")
{
DEF_CA
SFloat * sf_addr;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
sf_addr = vm_Cell2sf_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" sf_addr=", vm_out); printarg_sf_(sf_addr);
}
#endif
sp += 1;
fp += -1;
{
#line 1737 "./prim"
#ifdef IEEE_FP
r = *sf_addr;
#else
!! sf@
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "sf@");
NEXT_P2;}

I_s_f_store: /* sf! ( r sf_addr -- ) */
/* Store @i{r} as single-precision IEEE floating-point value to the
address @i{sf-addr}. */
NAME("sf!")
{
DEF_CA
Float r;
SFloat * sf_addr;
NEXT_P0;
r = vm_Float2r(fpTOS);
sf_addr = vm_Cell2sf_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" sf_addr=", vm_out); printarg_sf_(sf_addr);
}
#endif
sp += 1;
fp += 1;
{
#line 1746 "./prim"
#ifdef IEEE_FP
*sf_addr = r;
#else
!! sf!
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "sf!");
NEXT_P2;}

I_f_plus: /* f+ ( r1 r2 -- r3 ) */
/*  */
NAME("f+")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1753 "./prim"
r3 = r1+r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "f+");
NEXT_P2;}

I_f_minus: /* f- ( r1 r2 -- r3 ) */
/*  */
NAME("f-")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1756 "./prim"
r3 = r1-r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "f-");
NEXT_P2;}

I_f_star: /* f* ( r1 r2 -- r3 ) */
/*  */
NAME("f*")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1759 "./prim"
r3 = r1*r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "f*");
NEXT_P2;}

I_f_slash: /* f/ ( r1 r2 -- r3 ) */
/*  */
NAME("f/")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1762 "./prim"
r3 = r1/r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "f/");
NEXT_P2;}

I_f_star_star: /* f** ( r1 r2 -- r3 ) */
/* @i{r3} is @i{r1} raised to the @i{r2}th power. */
NAME("f**")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1766 "./prim"
r3 = pow(r1,r2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "f**");
NEXT_P2;}

I_f_negate: /* fnegate ( r1 -- r2 ) */
/*  */
NAME("fnegate")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1769 "./prim"
r2 = - r1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fnegate");
NEXT_P2;}

I_f_drop: /* fdrop ( r -- ) */
/*  */
NAME("fdrop")
{
DEF_CA
Float r;
NEXT_P0;
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
fp += 1;
{
#line 1772 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "fdrop");
NEXT_P2;}

I_f_dupe: /* fdup ( r -- r r ) */
/*  */
NAME("fdup")
{
DEF_CA
Float r;
NEXT_P0;
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
fp += -1;
{
#line 1774 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(fp[1] = vm_r2Float(r););
fpTOS = vm_r2Float(r);
trace_btb(0 , "fdup");
NEXT_P2;}

I_f_swap: /* fswap ( r1 r2 -- r2 r1 ) */
/*  */
NAME("fswap")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
{
#line 1776 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
fp[1] = vm_r2Float(r2);
fpTOS = vm_r2Float(r1);
trace_btb(0 , "fswap");
NEXT_P2;}

I_f_over: /* fover ( r1 r2 -- r1 r2 r1 ) */
/*  */
NAME("fover")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += -1;
{
#line 1778 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(fp[1] = vm_r2Float(r2););
fpTOS = vm_r2Float(r1);
trace_btb(0 , "fover");
NEXT_P2;}

I_f_rote: /* frot ( r1 r2 r3 -- r2 r3 r1 ) */
/*  */
NAME("frot")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[2]);
r2 = vm_Float2r(fp[1]);
r3 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
fputs(" r3=", vm_out); printarg_r(r3);
}
#endif
{
#line 1780 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
fp[2] = vm_r2Float(r2);
fp[1] = vm_r2Float(r3);
fpTOS = vm_r2Float(r1);
trace_btb(0 , "frot");
NEXT_P2;}

I_f_nip: /* fnip ( r1 r2 -- r2 ) */
/*  */
NAME("fnip")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1782 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fnip");
NEXT_P2;}

I_f_tuck: /* ftuck ( r1 r2 -- r2 r1 r2 ) */
/*  */
NAME("ftuck")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += -1;
{
#line 1784 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
fp[2] = vm_r2Float(r2);
fp[1] = vm_r2Float(r1);
fpTOS = vm_r2Float(r2);
trace_btb(0 , "ftuck");
NEXT_P2;}

I_float_plus: /* float+ ( f_addr1 -- f_addr2 ) */
/* @code{1 floats +}. */
NAME("float+")
{
DEF_CA
Float * f_addr1;
Float * f_addr2;
NEXT_P0;
f_addr1 = vm_Cell2f_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr1=", vm_out); printarg_f_(f_addr1);
}
#endif
{
#line 1787 "./prim"
f_addr2 = f_addr1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f_addr2=", vm_out); printarg_f_(f_addr2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f_2Cell(f_addr2);
trace_btb(0 , "float+");
NEXT_P2;}

I_floats: /* floats ( n1 -- n2 ) */
/* @i{n2} is the number of address units of @i{n1} floats. */
NAME("floats")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1791 "./prim"
n2 = n1*sizeof(Float);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "floats");
NEXT_P2;}

I_floor: /* floor ( r1 -- r2 ) */
/* Round towards the next smaller integral value, i.e., round toward negative infinity. */
NAME("floor")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1795 "./prim"
/* !! unclear wording */
r2 = floor(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "floor");
NEXT_P2;}

I_f_round: /* fround ( r1 -- r2 ) */
/* Round to the nearest integral value. */
NAME("fround")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1800 "./prim"
/* !! unclear wording */
#ifdef HAVE_RINT
r2 = rint(r1);
#else
r2 = floor(r1+0.5);
/* !! This is not quite true to the rounding rules given in the standard */
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fround");
NEXT_P2;}

I_f_max: /* fmax ( r1 r2 -- r3 ) */
/*  */
NAME("fmax")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1809 "./prim"
if (r1<r2)
  r3 = r2;
else
  r3 = r1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "fmax");
NEXT_P2;}

I_f_min: /* fmin ( r1 r2 -- r3 ) */
/*  */
NAME("fmin")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1815 "./prim"
if (r1<r2)
  r3 = r1;
else
  r3 = r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "fmin");
NEXT_P2;}

I_represent: /* represent ( r c_addr u -- n f1 f2 ) */
/*  */
NAME("represent")
{
DEF_CA
Float r;
Char * c_addr;
UCell u;
Cell n;
Bool f1;
Bool f2;
NEXT_P0;
r = vm_Float2r(fpTOS);
c_addr = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += -1;
fp += 1;
{
#line 1821 "./prim"
char *sig;
int flag;
int decpt;
sig=ecvt(r, u, &decpt, &flag);
n=(r==0 ? 1 : decpt);
f1=FLAG(flag!=0);
f2=FLAG(isdigit((unsigned)(sig[0]))!=0);
memmove(c_addr,sig,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputs(" f1=", vm_out); printarg_f(f1);
fputs(" f2=", vm_out); printarg_f(f2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[2] = vm_n2Cell(n);
sp[1] = vm_f2Cell(f1);
spTOS = vm_f2Cell(f2);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "represent");
NEXT_P2;}

I_to_float: /* >float ( c_addr u -- flag ) */
/* Actual stack effect: ( c_addr u -- r t | f ).  Attempt to convert the
character string @i{c-addr u} to internal floating-point
representation. If the string represents a valid floating-point number
@i{r} is placed on the floating-point stack and @i{flag} is
true. Otherwise, @i{flag} is false. A string of blanks is a special
case and represents the floating-point number 0. */
NAME(">float")
{
DEF_CA
Char * c_addr;
UCell u;
Bool flag;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 1837 "./prim"
/* real signature: c_addr u -- r t / f */
Float r;
char *number=cstr(c_addr, u, 1);
char *endconv;
int sign = 0;
if(number[0]=='-') {
   sign = 1;
   number++;
   u--;
}
while(isspace((unsigned)(number[--u])) && u>0);
switch(number[u])
{
   case 'd':
   case 'D':
   case 'e':
   case 'E':  break;
   default :  u++; break;
}
number[u]='\0';
r=strtod(number,&endconv);
if((flag=FLAG(!(Cell)*endconv)))
{
   IF_fpTOS(fp[0] = fpTOS);
   fp += -1;
   fpTOS = sign ? -r : r;
}
else if(*endconv=='d' || *endconv=='D')
{
   *endconv='E';
   r=strtod(number,&endconv);
   if((flag=FLAG(!(Cell)*endconv)))
     {
	IF_fpTOS(fp[0] = fpTOS);
	fp += -1;
	fpTOS = sign ? -r : r;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" flag=", vm_out); printarg_f(flag);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(flag);
trace_btb(0 , ">float");
NEXT_P2;}

I_f_abs: /* fabs ( r1 -- r2 ) */
/*  */
NAME("fabs")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1877 "./prim"
r2 = fabs(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fabs");
NEXT_P2;}

I_f_a_cos: /* facos ( r1 -- r2 ) */
/*  */
NAME("facos")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1880 "./prim"
r2 = acos(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "facos");
NEXT_P2;}

I_f_a_sine: /* fasin ( r1 -- r2 ) */
/*  */
NAME("fasin")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1883 "./prim"
r2 = asin(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fasin");
NEXT_P2;}

I_f_a_tan: /* fatan ( r1 -- r2 ) */
/*  */
NAME("fatan")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1886 "./prim"
r2 = atan(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fatan");
NEXT_P2;}

I_f_a_tan_two: /* fatan2 ( r1 r2 -- r3 ) */
/* @i{r1/r2}=tan(@i{r3}). ANS Forth does not require, but probably
intends this to be the inverse of @code{fsincos}. In gforth it is. */
NAME("fatan2")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fp[1]);
r2 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1891 "./prim"
r3 = atan2(r1,r2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r3);
trace_btb(0 , "fatan2");
NEXT_P2;}

I_f_cos: /* fcos ( r1 -- r2 ) */
/*  */
NAME("fcos")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1894 "./prim"
r2 = cos(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fcos");
NEXT_P2;}

I_f_e_x_p: /* fexp ( r1 -- r2 ) */
/*  */
NAME("fexp")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1897 "./prim"
r2 = exp(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fexp");
NEXT_P2;}

I_f_e_x_p_m_one: /* fexpm1 ( r1 -- r2 ) */
/* @i{r2}=@i{e}**@i{r1}@minus{}1 */
NAME("fexpm1")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1901 "./prim"
#ifdef HAVE_EXPM1
extern double
#ifdef NeXT
              const
#endif
                    expm1(double);
r2 = expm1(r1);
#else
r2 = exp(r1)-1.;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fexpm1");
NEXT_P2;}

I_f_l_n: /* fln ( r1 -- r2 ) */
/*  */
NAME("fln")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1913 "./prim"
r2 = log(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fln");
NEXT_P2;}

I_f_l_n_p_one: /* flnp1 ( r1 -- r2 ) */
/* @i{r2}=ln(@i{r1}+1) */
NAME("flnp1")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1917 "./prim"
#ifdef HAVE_LOG1P
extern double
#ifdef NeXT
              const
#endif
                    log1p(double);
r2 = log1p(r1);
#else
r2 = log(r1+1.);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "flnp1");
NEXT_P2;}

I_f_log: /* flog ( r1 -- r2 ) */
/* The decimal logarithm. */
NAME("flog")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1930 "./prim"
r2 = log10(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "flog");
NEXT_P2;}

I_f_a_log: /* falog ( r1 -- r2 ) */
/* @i{r2}=10**@i{r1} */
NAME("falog")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1934 "./prim"
extern double pow10(double);
r2 = pow10(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "falog");
NEXT_P2;}

I_f_sine: /* fsin ( r1 -- r2 ) */
/*  */
NAME("fsin")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1938 "./prim"
r2 = sin(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fsin");
NEXT_P2;}

I_f_sine_cos: /* fsincos ( r1 -- r2 r3 ) */
/* @i{r2}=sin(@i{r1}), @i{r3}=cos(@i{r1}) */
NAME("fsincos")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
fp += -1;
{
#line 1942 "./prim"
r2 = sin(r1);
r3 = cos(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fp[1] = vm_r2Float(r2);
fpTOS = vm_r2Float(r3);
trace_btb(0 , "fsincos");
NEXT_P2;}

I_f_square_root: /* fsqrt ( r1 -- r2 ) */
/*  */
NAME("fsqrt")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1946 "./prim"
r2 = sqrt(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fsqrt");
NEXT_P2;}

I_f_tan: /* ftan ( r1 -- r2 ) */
/*  */
NAME("ftan")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1949 "./prim"
r2 = tan(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "ftan");
NEXT_P2;}

I_f_cinch: /* fsinh ( r1 -- r2 ) */
/*  */
NAME("fsinh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1954 "./prim"
r2 = sinh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fsinh");
NEXT_P2;}

I_f_cosh: /* fcosh ( r1 -- r2 ) */
/*  */
NAME("fcosh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1959 "./prim"
r2 = cosh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fcosh");
NEXT_P2;}

I_f_tan_h: /* ftanh ( r1 -- r2 ) */
/*  */
NAME("ftanh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1964 "./prim"
r2 = tanh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "ftanh");
NEXT_P2;}

I_f_a_cinch: /* fasinh ( r1 -- r2 ) */
/*  */
NAME("fasinh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1969 "./prim"
r2 = asinh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fasinh");
NEXT_P2;}

I_f_a_cosh: /* facosh ( r1 -- r2 ) */
/*  */
NAME("facosh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1974 "./prim"
r2 = acosh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "facosh");
NEXT_P2;}

I_f_a_tan_h: /* fatanh ( r1 -- r2 ) */
/*  */
NAME("fatanh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
r1 = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1979 "./prim"
r2 = atanh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r2);
trace_btb(0 , "fatanh");
NEXT_P2;}

I_s_floats: /* sfloats ( n1 -- n2 ) */
/* @i{n2} is the number of address units of @i{n1}
single-precision IEEE floating-point numbers. */
NAME("sfloats")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1987 "./prim"
n2 = n1*sizeof(SFloat);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "sfloats");
NEXT_P2;}

I_d_floats: /* dfloats ( n1 -- n2 ) */
/* @i{n2} is the number of address units of @i{n1}
double-precision IEEE floating-point numbers. */
NAME("dfloats")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
n1 = vm_Cell2n(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1992 "./prim"
n2 = n1*sizeof(DFloat);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_n2Cell(n2);
trace_btb(0 , "dfloats");
NEXT_P2;}

I_s_f_aligned: /* sfaligned ( c_addr -- sf_addr ) */
/* @i{sf-addr} is the first single-float-aligned address greater
than or equal to @i{c-addr}. */
NAME("sfaligned")
{
DEF_CA
Char * c_addr;
SFloat * sf_addr;
NEXT_P0;
c_addr = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 1997 "./prim"
sf_addr = (SFloat *)((((Cell)c_addr)+(sizeof(SFloat)-1))&(-sizeof(SFloat)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" sf_addr=", vm_out); printarg_sf_(sf_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_sf_2Cell(sf_addr);
trace_btb(0 , "sfaligned");
NEXT_P2;}

I_d_f_aligned: /* dfaligned ( c_addr -- df_addr ) */
/* @i{df-addr} is the first double-float-aligned address greater
than or equal to @i{c-addr}. */
NAME("dfaligned")
{
DEF_CA
Char * c_addr;
DFloat * df_addr;
NEXT_P0;
c_addr = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 2004 "./prim"
df_addr = (DFloat *)((((Cell)c_addr)+(sizeof(DFloat)-1))&(-sizeof(DFloat)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" df_addr=", vm_out); printarg_df_(df_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_df_2Cell(df_addr);
trace_btb(0 , "dfaligned");
NEXT_P2;}

#endif
#ifdef HAS_GLOCALS
I_fetch_local_number: /* @local# ( #noffset -- w ) */
/*  */
NAME("@local#")
{
DEF_CA
Cell noffset;
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
noffset = vm_Cell2n(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
sp += -1;
{
#line 2018 "./prim"
w = *(Cell *)(lp+noffset);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "@local#");
NEXT_P2;}

I_fetch_local_zero: /* @local0 ( -- w ) */
/*  */
NAME("@local0")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2021 "./prim"
w = *(Cell *)(lp+0*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "@local0");
NEXT_P2;}

I_fetch_local_four: /* @local1 ( -- w ) */
/*  */
NAME("@local1")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2024 "./prim"
w = *(Cell *)(lp+1*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "@local1");
NEXT_P2;}

I_fetch_local_eight: /* @local2 ( -- w ) */
/*  */
NAME("@local2")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2027 "./prim"
w = *(Cell *)(lp+2*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "@local2");
NEXT_P2;}

I_fetch_local_twelve: /* @local3 ( -- w ) */
/*  */
NAME("@local3")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2030 "./prim"
w = *(Cell *)(lp+3*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(w);
trace_btb(0 , "@local3");
NEXT_P2;}

#ifdef HAS_FLOATING
I_f_fetch_local_number: /* f@local# ( #noffset -- r ) */
/*  */
NAME("f@local#")
{
DEF_CA
Cell noffset;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
noffset = vm_Cell2n(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
fp += -1;
{
#line 2035 "./prim"
r = *(Float *)(lp+noffset);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
trace_btb(0 , "f@local#");
NEXT_P2;}

I_f_fetch_local_zero: /* f@local0 ( -- r ) */
/*  */
NAME("f@local0")
{
DEF_CA
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
fp += -1;
{
#line 2038 "./prim"
r = *(Float *)(lp+0*sizeof(Float));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
trace_btb(0 , "f@local0");
NEXT_P2;}

I_f_fetch_local_eight: /* f@local1 ( -- r ) */
/*  */
NAME("f@local1")
{
DEF_CA
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
fp += -1;
{
#line 2041 "./prim"
r = *(Float *)(lp+1*sizeof(Float));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
trace_btb(0 , "f@local1");
NEXT_P2;}

#endif
I_laddr_number: /* laddr# ( #noffset -- c_addr ) */
/*  */
NAME("laddr#")
{
DEF_CA
Cell noffset;
Char * c_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
noffset = vm_Cell2n(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
sp += -1;
{
#line 2046 "./prim"
/* this can also be used to implement lp@ */
c_addr = (Char *)(lp+noffset);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_c_2Cell(c_addr);
trace_btb(0 , "laddr#");
NEXT_P2;}

I_lp_plus_store_number: /* lp+!# ( #noffset -- ) */
/* used with negative immediate values it allocates memory on the
local stack, a positive immediate argument drops memory from the local
stack */
NAME("lp+!#")
{
DEF_CA
Cell noffset;
NEXT_P0;
noffset = vm_Cell2n(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
{
#line 2053 "./prim"
lp += noffset;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "lp+!#");
NEXT_P2;}

I_minus_four_lp_plus_store: /* lp- ( -- ) */
/*  */
NAME("lp-")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 2056 "./prim"
lp += -sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "lp-");
NEXT_P2;}

I_eight_lp_plus_store: /* lp+ ( -- ) */
/*  */
NAME("lp+")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 2059 "./prim"
lp += sizeof(Float);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "lp+");
NEXT_P2;}

I_sixteen_lp_plus_store: /* lp+2 ( -- ) */
/*  */
NAME("lp+2")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 2062 "./prim"
lp += 2*sizeof(Float);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
trace_btb(0 , "lp+2");
NEXT_P2;}

I_lp_store: /* lp! ( c_addr -- ) */
/*  */
NAME("lp!")
{
DEF_CA
Char * c_addr;
NEXT_P0;
c_addr = vm_Cell2c_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
sp += 1;
{
#line 2065 "./prim"
lp = (Address)c_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "lp!");
NEXT_P2;}

I_to_l: /* >l ( w -- ) */
/*  */
NAME(">l")
{
DEF_CA
Cell w;
NEXT_P0;
w = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
{
#line 2068 "./prim"
lp -= sizeof(Cell);
*(Cell *)lp = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , ">l");
NEXT_P2;}

#ifdef HAS_FLOATING
I_f_to_l: /* f>l ( r -- ) */
/*  */
NAME("f>l")
{
DEF_CA
Float r;
NEXT_P0;
r = vm_Float2r(fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
fp += 1;
{
#line 2074 "./prim"
lp -= sizeof(Float);
*(Float *)lp = r;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "f>l");
NEXT_P2;}

I_fpick: /* fpick ( u -- r ) */
/* Actually the stack effect is @code{ r0 ... ru u -- r0 ... ru r0 }. */
NAME("fpick")
{
DEF_CA
UCell u;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
fp += -1;
{
#line 2079 "./prim"
r = fp[u+1]; /* +1, because update of fp happens before this fragment */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fpick");
NEXT_P2;}

#endif
#endif
#ifdef HAS_OS
I_open_lib: /* open-lib ( c_addr1 u1 -- u2 ) */
/*  */
NAME("open-lib")
{
DEF_CA
Char * c_addr1;
UCell u1;
UCell u2;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[1]);
u1 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
sp += 1;
{
#line 2120 "./prim"
#if defined(HAVE_LIBDL) || defined(HAVE_DLOPEN)
#ifndef RTLD_GLOBAL
#define RTLD_GLOBAL 0
#endif
u2=(UCell) dlopen(cstr(c_addr1, u1, 1), RTLD_GLOBAL | RTLD_LAZY);
#else
#  ifdef _WIN32
u2 = (Cell) GetModuleHandle(cstr(c_addr1, u1, 1));
#  else
#warning Define open-lib!
u2 = 0;
#  endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(u2);
trace_btb(0 , "open-lib");
NEXT_P2;}

I_lib_sym: /* lib-sym ( c_addr1 u1 u2 -- u3 ) */
/*  */
NAME("lib-sym")
{
DEF_CA
Char * c_addr1;
UCell u1;
UCell u2;
UCell u3;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[2]);
u1 = vm_Cell2u(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 2;
{
#line 2135 "./prim"
#if defined(HAVE_LIBDL) || defined(HAVE_DLOPEN)
u3 = (UCell) dlsym((void*)u2,cstr(c_addr1, u1, 1));
#else
#  ifdef _WIN32
u3 = (Cell) GetProcAddress((HMODULE)u2, cstr(c_addr1, u1, 1));
#  else
#warning Define lib-sym!
u3 = 0;
#  endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u3=", vm_out); printarg_u(u3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(u3);
trace_btb(0 , "lib-sym");
NEXT_P2;}

I_icall0: /* icall0 ( u -- uret ) */
/*  */
NAME("icall0")
{
DEF_CA
UCell u;
UCell uret;
NEXT_P0;
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 2146 "./prim"
uret = (SYSCALL(Cell(*)())u)();
#line 2146
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall0");
NEXT_P2;}

I_icall1: /* icall1 ( u1 u -- uret ) */
/*  */
NAME("icall1")
{
DEF_CA
UCell u1;
UCell u;
UCell uret;
NEXT_P0;
u1 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 2146 "./prim"
uret = (SYSCALL(Cell(*)(Cell))u)(u1);
#line 2146
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall1");
NEXT_P2;}

I_icall2: /* icall2 ( u1 u2 u -- uret ) */
/*  */
NAME("icall2")
{
DEF_CA
UCell u1;
UCell u2;
UCell u;
UCell uret;
NEXT_P0;
u1 = vm_Cell2u(sp[2]);
u2 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 2;
{
#line 2146 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell))u)(u1, u2);
#line 2146
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall2");
NEXT_P2;}

I_icall3: /* icall3 ( u1 u2 u3 u -- uret ) */
/*  */
NAME("icall3")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u;
UCell uret;
NEXT_P0;
u1 = vm_Cell2u(sp[3]);
u2 = vm_Cell2u(sp[2]);
u3 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
{
#line 2146 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell))u)(u1, u2, u3);
#line 2146
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall3");
NEXT_P2;}

I_icall4: /* icall4 ( u1 u2 u3 u4 u -- uret ) */
/*  */
NAME("icall4")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u;
UCell uret;
NEXT_P0;
u1 = vm_Cell2u(sp[4]);
u2 = vm_Cell2u(sp[3]);
u3 = vm_Cell2u(sp[2]);
u4 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 4;
{
#line 2146 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4);
#line 2146
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall4");
NEXT_P2;}

I_icall5: /* icall5 ( u1 u2 u3 u4 u5 u -- uret ) */
/*  */
NAME("icall5")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u;
UCell uret;
NEXT_P0;
u1 = vm_Cell2u(sp[5]);
u2 = vm_Cell2u(sp[4]);
u3 = vm_Cell2u(sp[3]);
u4 = vm_Cell2u(sp[2]);
u5 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 5;
{
#line 2146 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5);
#line 2146
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall5");
NEXT_P2;}

I_icall6: /* icall6 ( u1 u2 u3 u4 u5 u6 u -- uret ) */
/*  */
NAME("icall6")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u;
UCell uret;
NEXT_P0;
u1 = vm_Cell2u(sp[6]);
u2 = vm_Cell2u(sp[5]);
u3 = vm_Cell2u(sp[4]);
u4 = vm_Cell2u(sp[3]);
u5 = vm_Cell2u(sp[2]);
u6 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 6;
{
#line 2146 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6);
#line 2146
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall6");
NEXT_P2;}

I_icall20: /* icall20 ( u1 u2 u3 u4 u5 u6 u7 u8 u9 u10 u11 u12 u13 u14 u15 u16 u17 u18 u19 u20 u -- uret ) */
/*  */
NAME("icall20")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u7;
UCell u8;
UCell u9;
UCell u10;
UCell u11;
UCell u12;
UCell u13;
UCell u14;
UCell u15;
UCell u16;
UCell u17;
UCell u18;
UCell u19;
UCell u20;
UCell u;
UCell uret;
NEXT_P0;
u1 = vm_Cell2u(sp[20]);
u2 = vm_Cell2u(sp[19]);
u3 = vm_Cell2u(sp[18]);
u4 = vm_Cell2u(sp[17]);
u5 = vm_Cell2u(sp[16]);
u6 = vm_Cell2u(sp[15]);
u7 = vm_Cell2u(sp[14]);
u8 = vm_Cell2u(sp[13]);
u9 = vm_Cell2u(sp[12]);
u10 = vm_Cell2u(sp[11]);
u11 = vm_Cell2u(sp[10]);
u12 = vm_Cell2u(sp[9]);
u13 = vm_Cell2u(sp[8]);
u14 = vm_Cell2u(sp[7]);
u15 = vm_Cell2u(sp[6]);
u16 = vm_Cell2u(sp[5]);
u17 = vm_Cell2u(sp[4]);
u18 = vm_Cell2u(sp[3]);
u19 = vm_Cell2u(sp[2]);
u20 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u7=", vm_out); printarg_u(u7);
fputs(" u8=", vm_out); printarg_u(u8);
fputs(" u9=", vm_out); printarg_u(u9);
fputs(" u10=", vm_out); printarg_u(u10);
fputs(" u11=", vm_out); printarg_u(u11);
fputs(" u12=", vm_out); printarg_u(u12);
fputs(" u13=", vm_out); printarg_u(u13);
fputs(" u14=", vm_out); printarg_u(u14);
fputs(" u15=", vm_out); printarg_u(u15);
fputs(" u16=", vm_out); printarg_u(u16);
fputs(" u17=", vm_out); printarg_u(u17);
fputs(" u18=", vm_out); printarg_u(u18);
fputs(" u19=", vm_out); printarg_u(u19);
fputs(" u20=", vm_out); printarg_u(u20);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 20;
{
#line 2147 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6, u7, u8, u9, u10, u11, u12, u13, u14, u15, u16, u17, u18, u19, u20);
#line 2147
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_u2Cell(uret);
trace_btb(0 , "icall20");
NEXT_P2;}

I_fcall0: /* fcall0 ( u -- rret ) */
/*  */
NAME("fcall0")
{
DEF_CA
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
fp += -1;
{
#line 2148 "./prim"
rret = (SYSCALL(Float(*)())u)();
#line 2148
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall0");
NEXT_P2;}

I_fcall1: /* fcall1 ( u1 u -- rret ) */
/*  */
NAME("fcall1")
{
DEF_CA
UCell u1;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u1 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 2;
fp += -1;
{
#line 2148 "./prim"
rret = (SYSCALL(Float(*)(Cell))u)(u1);
#line 2148
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall1");
NEXT_P2;}

I_fcall2: /* fcall2 ( u1 u2 u -- rret ) */
/*  */
NAME("fcall2")
{
DEF_CA
UCell u1;
UCell u2;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u1 = vm_Cell2u(sp[2]);
u2 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
fp += -1;
{
#line 2148 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell))u)(u1, u2);
#line 2148
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall2");
NEXT_P2;}

I_fcall3: /* fcall3 ( u1 u2 u3 u -- rret ) */
/*  */
NAME("fcall3")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u1 = vm_Cell2u(sp[3]);
u2 = vm_Cell2u(sp[2]);
u3 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 4;
fp += -1;
{
#line 2148 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell))u)(u1, u2, u3);
#line 2148
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall3");
NEXT_P2;}

I_fcall4: /* fcall4 ( u1 u2 u3 u4 u -- rret ) */
/*  */
NAME("fcall4")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u1 = vm_Cell2u(sp[4]);
u2 = vm_Cell2u(sp[3]);
u3 = vm_Cell2u(sp[2]);
u4 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 5;
fp += -1;
{
#line 2148 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4);
#line 2148
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall4");
NEXT_P2;}

I_fcall5: /* fcall5 ( u1 u2 u3 u4 u5 u -- rret ) */
/*  */
NAME("fcall5")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u1 = vm_Cell2u(sp[5]);
u2 = vm_Cell2u(sp[4]);
u3 = vm_Cell2u(sp[3]);
u4 = vm_Cell2u(sp[2]);
u5 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 6;
fp += -1;
{
#line 2148 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5);
#line 2148
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall5");
NEXT_P2;}

I_fcall6: /* fcall6 ( u1 u2 u3 u4 u5 u6 u -- rret ) */
/*  */
NAME("fcall6")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u1 = vm_Cell2u(sp[6]);
u2 = vm_Cell2u(sp[5]);
u3 = vm_Cell2u(sp[4]);
u4 = vm_Cell2u(sp[3]);
u5 = vm_Cell2u(sp[2]);
u6 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 7;
fp += -1;
{
#line 2148 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6);
#line 2148
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall6");
NEXT_P2;}

I_fcall20: /* fcall20 ( u1 u2 u3 u4 u5 u6 u7 u8 u9 u10 u11 u12 u13 u14 u15 u16 u17 u18 u19 u20 u -- rret ) */
/*  */
NAME("fcall20")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u7;
UCell u8;
UCell u9;
UCell u10;
UCell u11;
UCell u12;
UCell u13;
UCell u14;
UCell u15;
UCell u16;
UCell u17;
UCell u18;
UCell u19;
UCell u20;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
u1 = vm_Cell2u(sp[20]);
u2 = vm_Cell2u(sp[19]);
u3 = vm_Cell2u(sp[18]);
u4 = vm_Cell2u(sp[17]);
u5 = vm_Cell2u(sp[16]);
u6 = vm_Cell2u(sp[15]);
u7 = vm_Cell2u(sp[14]);
u8 = vm_Cell2u(sp[13]);
u9 = vm_Cell2u(sp[12]);
u10 = vm_Cell2u(sp[11]);
u11 = vm_Cell2u(sp[10]);
u12 = vm_Cell2u(sp[9]);
u13 = vm_Cell2u(sp[8]);
u14 = vm_Cell2u(sp[7]);
u15 = vm_Cell2u(sp[6]);
u16 = vm_Cell2u(sp[5]);
u17 = vm_Cell2u(sp[4]);
u18 = vm_Cell2u(sp[3]);
u19 = vm_Cell2u(sp[2]);
u20 = vm_Cell2u(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u7=", vm_out); printarg_u(u7);
fputs(" u8=", vm_out); printarg_u(u8);
fputs(" u9=", vm_out); printarg_u(u9);
fputs(" u10=", vm_out); printarg_u(u10);
fputs(" u11=", vm_out); printarg_u(u11);
fputs(" u12=", vm_out); printarg_u(u12);
fputs(" u13=", vm_out); printarg_u(u13);
fputs(" u14=", vm_out); printarg_u(u14);
fputs(" u15=", vm_out); printarg_u(u15);
fputs(" u16=", vm_out); printarg_u(u16);
fputs(" u17=", vm_out); printarg_u(u17);
fputs(" u18=", vm_out); printarg_u(u18);
fputs(" u19=", vm_out); printarg_u(u19);
fputs(" u20=", vm_out); printarg_u(u20);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 21;
fp += -1;
{
#line 2149 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6, u7, u8, u9, u10, u11, u12, u13, u14, u15, u16, u17, u18, u19, u20);
#line 2149
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(rret);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "fcall20");
NEXT_P2;}

#endif
I_up_store: /* up! ( a_addr -- ) */
/*  */
NAME("up!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 2154 "./prim"
UP=up=(char *)a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "up!");
NEXT_P2;}

I_wcall: /* wcall ( u -- ) */
/*  */
NAME("wcall")
{
DEF_CA
UCell u;
NEXT_P0;
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 2160 "./prim"
IF_fpTOS(fp[0]=fpTOS);
FP=fp;
sp=(Cell*)(SYSCALL(Cell(*)(Cell *, void *))u)(sp, &FP);
fp=FP;
IF_spTOS(spTOS=sp[0];)
IF_fpTOS(fpTOS=fp[0]);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "wcall");
NEXT_P2;}

#ifdef HAS_FILE
I_open_dir: /* open-dir ( c_addr u -- wdirid wior ) */
/*  */
NAME("open-dir")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wdirid;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[1]);
u = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 2170 "./prim"
wdirid = (Cell)opendir(tilde_cstr(c_addr, u, 1));
wior =  IOR(wdirid == 0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wdirid=", vm_out); printarg_w(wdirid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_w2Cell(wdirid);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "open-dir");
NEXT_P2;}

I_read_dir: /* read-dir ( c_addr u1 wdirid -- u2 flag wior ) */
/*  */
NAME("read-dir")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wdirid;
UCell u2;
Bool flag;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u1 = vm_Cell2u(sp[1]);
wdirid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wdirid=", vm_out); printarg_w(wdirid);
}
#endif
{
#line 2174 "./prim"
struct dirent * dent;
dent = readdir((DIR *)wdirid);
wior = 0;
flag = -1;
if(dent == NULL) {
  u2 = 0;
  flag = 0;
} else {
  u2 = strlen(dent->d_name);
  if(u2 > u1) {
    u2 = u1;
    wior = -512-ENAMETOOLONG;
  }
  memmove(c_addr, dent->d_name, u2);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" flag=", vm_out); printarg_f(flag);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[2] = vm_u2Cell(u2);
sp[1] = vm_f2Cell(flag);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "read-dir");
NEXT_P2;}

I_close_dir: /* close-dir ( wdirid -- wior ) */
/*  */
NAME("close-dir")
{
DEF_CA
Cell wdirid;
Cell wior;
NEXT_P0;
wdirid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wdirid=", vm_out); printarg_w(wdirid);
}
#endif
{
#line 2191 "./prim"
wior = IOR(closedir((DIR *)wdirid));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wior);
trace_btb(0 , "close-dir");
NEXT_P2;}

I_match_file: /* filename-match ( c_addr1 u1 c_addr2 u2 -- flag ) */
/*  */
NAME("filename-match")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
Bool flag;
NEXT_P0;
c_addr1 = vm_Cell2c_(sp[3]);
u1 = vm_Cell2u(sp[2]);
c_addr2 = vm_Cell2c_(sp[1]);
u2 = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 3;
{
#line 2194 "./prim"
char * string = cstr(c_addr1, u1, 1);
char * pattern = cstr(c_addr2, u2, 0);
flag = FLAG(!fnmatch(pattern, string, 0));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" flag=", vm_out); printarg_f(flag);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_f2Cell(flag);
trace_btb(0 , "filename-match");
NEXT_P2;}

#endif
I_newline: /* newline ( -- c_addr u ) */
/* String containing the newline sequence of the host OS */
NAME("newline")
{
DEF_CA
Char * c_addr;
UCell u;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -2;
{
#line 2202 "./prim"
char newline[] = {
#if defined(unix) || defined(__MACH__)
/* Darwin/MacOS X sets __MACH__, but not unix. */
'\n'
#else
'\r','\n'
#endif
};
c_addr=newline;
u=sizeof(newline);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[1] = vm_c_2Cell(c_addr);
spTOS = vm_u2Cell(u);
trace_btb(0 , "newline");
NEXT_P2;}

#ifdef HAS_OS
I_utime: /* utime ( -- dtime ) */
/* Report the current time in microseconds since some epoch. */
NAME("utime")
{
DEF_CA
DCell dtime;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -2;
{
#line 2220 "./prim"
struct timeval time1;
gettimeofday(&time1,NULL);
dtime = timeval2us(&time1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" dtime=", vm_out); printarg_d(dtime);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(dtime, sp[1], spTOS);
trace_btb(0 , "utime");
NEXT_P2;}

I_cputime: /* cputime ( -- duser dsystem ) */
/* duser and dsystem are the respective user- and system-level CPU
times used since the start of the Forth system (excluding child
processes), in microseconds (the granularity may be much larger,
however).  On platforms without the getrusage call, it reports elapsed
time (since some epoch) for duser and 0 for dsystem. */
NAME("cputime")
{
DEF_CA
DCell duser;
DCell dsystem;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -4;
{
#line 2230 "./prim"
#ifdef HAVE_GETRUSAGE
struct rusage usage;
getrusage(RUSAGE_SELF, &usage);
duser = timeval2us(&usage.ru_utime);
dsystem = timeval2us(&usage.ru_stime);
#else
struct timeval time1;
gettimeofday(&time1,NULL);
duser = timeval2us(&time1);
#ifndef BUGGY_LONG_LONG
dsystem = (DCell)0;
#else
dsystem=(DCell){0,0};
#endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" duser=", vm_out); printarg_d(duser);
fputs(" dsystem=", vm_out); printarg_d(dsystem);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(duser, sp[3], sp[2]);
vm_d2twoCell(dsystem, sp[1], spTOS);
trace_btb(0 , "cputime");
NEXT_P2;}

#endif
#ifdef HAS_FLOATING
I_v_star: /* v* ( f_addr1 nstride1 f_addr2 nstride2 ucount -- r ) */
/* dot-product: r=v1*v2.  The first element of v1 is at f_addr1, the
next at f_addr1+nstride1 and so on (similar for v2). Both vectors have
ucount elements. */
NAME("v*")
{
DEF_CA
Float * f_addr1;
Cell nstride1;
Float * f_addr2;
Cell nstride2;
UCell ucount;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
f_addr1 = vm_Cell2f_(sp[4]);
nstride1 = vm_Cell2n(sp[3]);
f_addr2 = vm_Cell2f_(sp[2]);
nstride2 = vm_Cell2n(sp[1]);
ucount = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr1=", vm_out); printarg_f_(f_addr1);
fputs(" nstride1=", vm_out); printarg_n(nstride1);
fputs(" f_addr2=", vm_out); printarg_f_(f_addr2);
fputs(" nstride2=", vm_out); printarg_n(nstride2);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
sp += 5;
fp += -1;
{
#line 2254 "./prim"
for (r=0.; ucount>0; ucount--) {
  r += *f_addr1 * *f_addr2;
  f_addr1 = (Float *)(((Address)f_addr1)+nstride1);
  f_addr2 = (Float *)(((Address)f_addr2)+nstride2);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
fpTOS = vm_r2Float(r);
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "v*");
NEXT_P2;}

I_faxpy: /* faxpy ( ra f_x nstridex f_y nstridey ucount -- ) */
/* vy=ra*vx+vy */
NAME("faxpy")
{
DEF_CA
Float ra;
Float * f_x;
Cell nstridex;
Float * f_y;
Cell nstridey;
UCell ucount;
NEXT_P0;
ra = vm_Float2r(fpTOS);
f_x = vm_Cell2f_(sp[4]);
nstridex = vm_Cell2n(sp[3]);
f_y = vm_Cell2f_(sp[2]);
nstridey = vm_Cell2n(sp[1]);
ucount = vm_Cell2u(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ra=", vm_out); printarg_r(ra);
fputs(" f_x=", vm_out); printarg_f_(f_x);
fputs(" nstridex=", vm_out); printarg_n(nstridex);
fputs(" f_y=", vm_out); printarg_f_(f_y);
fputs(" nstridey=", vm_out); printarg_n(nstridey);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
sp += 5;
fp += 1;
{
#line 2266 "./prim"
for (; ucount>0; ucount--) {
  *f_y += ra * *f_x;
  f_x = (Float *)(((Address)f_x)+nstridex);
  f_y = (Float *)(((Address)f_y)+nstridey);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
trace_btb(0 , "faxpy");
NEXT_P2;}

#endif
#ifdef HAS_FILE
I_paren_read_line: /* (read-line) ( c_addr u1 wfileid -- u2 flag u3 wior ) */
/*  */
NAME("(read-line)")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
UCell u2;
Bool flag;
UCell u3;
Cell wior;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u1 = vm_Cell2u(sp[1]);
wfileid = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -1;
{
#line 2281 "./prim"
Cell c;
flag=-1;
u3=0;
for(u2=0; u2<u1; u2++)
{
   c = getc((FILE *)wfileid);
   u3++;
   if (c=='\n') break;
   if (c=='\r') {
     if ((c = getc((FILE *)wfileid))!='\n')
       ungetc(c,(FILE *)wfileid);
     else
       u3++;
     break;
   }
   if (c==EOF) {
	flag=FLAG(u2!=0);
	break;
     }
   c_addr[u2] = (Char)c;
}
wior=FILEIO(ferror((FILE *)wfileid));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" flag=", vm_out); printarg_f(flag);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
sp[3] = vm_u2Cell(u2);
sp[2] = vm_f2Cell(flag);
sp[1] = vm_u2Cell(u3);
spTOS = vm_w2Cell(wior);
trace_btb(0 , "(read-line)");
NEXT_P2;}

#endif
I_paren_listlfind: /* (listlfind) ( c_addr u longname1 -- longname2 ) */
/*  */
NAME("(listlfind)")
{
DEF_CA
Char * c_addr;
UCell u;
struct Longname * longname1;
struct Longname * longname2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
longname1 = vm_Cell2longname(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" longname1=", vm_out); printarg_longname(longname1);
}
#endif
sp += 2;
{
#line 2307 "./prim"
for (; longname1 != NULL; longname1 = (struct Longname *)(longname1->next))
  if ((UCell)LONGNAME_COUNT(longname1)==u &&
      memcasecmp(c_addr, longname1->name, u)== 0 /* or inline? */)
    break;
longname2=longname1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" longname2=", vm_out); printarg_longname(longname2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_longname2Cell(longname2);
trace_btb(0 , "(listlfind)");
NEXT_P2;}

#ifdef HAS_HASH
I_paren_hashlfind: /* (hashlfind) ( c_addr u a_addr -- longname2 ) */
/*  */
NAME("(hashlfind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct Longname * longname2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 2324 "./prim"
struct Longname *longname1;
longname2=NULL;
while(a_addr != NULL)
{
   longname1=(struct Longname *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)LONGNAME_COUNT(longname1)==u &&
       memcasecmp(c_addr, longname1->name, u)== 0 /* or inline? */)
     {
	longname2=longname1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" longname2=", vm_out); printarg_longname(longname2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_longname2Cell(longname2);
trace_btb(0 , "(hashlfind)");
NEXT_P2;}

I_paren_tablelfind: /* (tablelfind) ( c_addr u a_addr -- longname2 ) */
/* A case-sensitive variant of @code{(hashfind)} */
NAME("(tablelfind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct Longname * longname2;
NEXT_P0;
c_addr = vm_Cell2c_(sp[2]);
u = vm_Cell2u(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 2347 "./prim"
struct Longname *longname1;
longname2=NULL;
while(a_addr != NULL)
{
   longname1=(struct Longname *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)LONGNAME_COUNT(longname1)==u &&
       memcmp(c_addr, longname1->name, u)== 0 /* or inline? */)
     {
	longname2=longname1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" longname2=", vm_out); printarg_longname(longname2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_longname2Cell(longname2);
trace_btb(0 , "(tablelfind)");
NEXT_P2;}

#endif
#ifdef HAS_PEEPHOLE
GROUP( peephole)
I_primtable: /* primtable ( -- wprimtable ) */
/* wprimtable is a table containing the xts of the primitives indexed
by sequence-number in prim (for use in prepare-peephole-table). */
NAME("primtable")
{
DEF_CA
Cell wprimtable;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2377 "./prim"
wprimtable = (Cell)primtable(symbols+DOESJUMP+1,MAX_SYMBOLS-DOESJUMP-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wprimtable=", vm_out); printarg_w(wprimtable);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wprimtable);
trace_btb(0 , "primtable");
NEXT_P2;}

I_prepare_peephole_opt: /* prepare-peephole-table ( wprimtable -- wpeeptable ) */
/* wpeeptable is a data structure used by @code{peephole-opt}; it is
constructed by combining a primitives table with a simple peephole
optimization table. */
NAME("prepare-peephole-table")
{
DEF_CA
Cell wprimtable;
Cell wpeeptable;
NEXT_P0;
wprimtable = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wprimtable=", vm_out); printarg_w(wprimtable);
}
#endif
{
#line 2383 "./prim"
wpeeptable = prepare_peephole_table((Xt *)wprimtable);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wpeeptable=", vm_out); printarg_w(wpeeptable);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_w2Cell(wpeeptable);
trace_btb(0 , "prepare-peephole-table");
NEXT_P2;}

I_peephole_opt: /* peephole-opt ( xt1 xt2 wpeeptable -- xt ) */
/* xt is the combination of xt1 and xt2 (according to wpeeptable); if
they cannot be combined, xt is 0. */
NAME("peephole-opt")
{
DEF_CA
Xt xt1;
Xt xt2;
Cell wpeeptable;
Xt xt;
NEXT_P0;
xt1 = vm_Cell2xt(sp[2]);
xt2 = vm_Cell2xt(sp[1]);
wpeeptable = vm_Cell2w(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt1=", vm_out); printarg_xt(xt1);
fputs(" xt2=", vm_out); printarg_xt(xt2);
fputs(" wpeeptable=", vm_out); printarg_w(wpeeptable);
}
#endif
sp += 2;
{
#line 2388 "./prim"
xt = peephole_opt(xt1, xt2, wpeeptable);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" xt=", vm_out); printarg_xt(xt);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_xt2Cell(xt);
trace_btb(0 , "peephole-opt");
NEXT_P2;}

I_call: /* call ( #a_callee -- R:a_retaddr ) */
/* Call callee (a variant of docol with inline argument). */
NAME("call")
{
DEF_CA
Cell * a_callee;
Cell * a_retaddr;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
a_callee = vm_Cell2a_(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
INC_IP(1);
rp += -1;
{
#line 2392 "./prim"
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
rpTOS = vm_a_2Cell(a_retaddr);
trace_btb(0 , "call");
NEXT_P2;}

I_useraddr: /* useraddr ( #u -- a_addr ) */
/*  */
NAME("useraddr")
{
DEF_CA
UCell u;
Cell * a_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
u = vm_Cell2u(IPTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
INC_IP(1);
sp += -1;
{
#line 2396 "./prim"
a_addr = (Cell *)(up+u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
spTOS = vm_a_2Cell(a_addr);
trace_btb(0 , "useraddr");
NEXT_P2;}

I_compile_note: /* compile-note ( xt a_addr -- ) */
/* notes that xt is compiled at addr */
NAME("compile-note")
{
DEF_CA
Xt xt;
Cell * a_addr;
NEXT_P0;
xt = vm_Cell2xt(sp[1]);
a_addr = vm_Cell2a_(spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 2400 "./prim"
compile_note(xt,a_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
trace_btb(0 , "compile-note");
NEXT_P2;}

#endif
